# coding: utf-8

"""
    AtroCore REST API documentation

    This is a REST API documentation for AtroCore data platform and its modules (AtroPIM, AtroDAM and others), which is based on [OpenAPI (Swagger) Specification](https://swagger.io/specification/). You can generate your client [here](https://openapi-generator.tech/docs/generators).<br><br><h3>Video tutorials:</h3><ul><li>[How to authorize?](https://youtu.be/GWfNRvCswXg)</li><li>[How to select specific fields?](https://youtu.be/i7o0aENuyuY)</li><li>[How to filter data records?](https://youtu.be/irgWkN4wlkM)</li></ul>

    The version of the OpenAPI document: 1.6.55
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import re  # noqa: F401
import io
import warnings

from pydantic import validate_arguments, ValidationError

from typing_extensions import Annotated
from pydantic import Field, StrictBool, StrictInt, StrictStr, conlist

from typing import Any, Dict, Optional

from clientapi_atrocore.models.category_asset import CategoryAsset
from clientapi_atrocore.models.create_category_asset_item_request import CreateCategoryAssetItemRequest
from clientapi_atrocore.models.follow_account200_response import FollowAccount200Response
from clientapi_atrocore.models.get_linked_items_for_account_item200_response import GetLinkedItemsForAccountItem200Response
from clientapi_atrocore.models.get_list_of_category_asset_items200_response import GetListOfCategoryAssetItems200Response
from clientapi_atrocore.models.link_account_request import LinkAccountRequest
from clientapi_atrocore.models.mass_update_account_request import MassUpdateAccountRequest

from clientapi_atrocore.api_client import ApiClient
from clientapi_atrocore.api_response import ApiResponse
from clientapi_atrocore.exceptions import (  # noqa: F401
    ApiTypeError,
    ApiValueError
)


class CategoryAssetApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client

    @validate_arguments
    def add_relation_for_category_asset(self, link : StrictStr, ids : conlist(StrictStr), foreign_ids : conlist(StrictStr), **kwargs) -> bool:  # noqa: E501
        """Add relation for CategoryAsset  # noqa: E501

        Add relation for CategoryAsset  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.add_relation_for_category_asset(link, ids, foreign_ids, async_req=True)
        >>> result = thread.get()

        :param link: (required)
        :type link: str
        :param ids: (required)
        :type ids: List[str]
        :param foreign_ids: (required)
        :type foreign_ids: List[str]
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: bool
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the add_relation_for_category_asset_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.add_relation_for_category_asset_with_http_info(link, ids, foreign_ids, **kwargs)  # noqa: E501

    @validate_arguments
    def add_relation_for_category_asset_with_http_info(self, link : StrictStr, ids : conlist(StrictStr), foreign_ids : conlist(StrictStr), **kwargs) -> ApiResponse:  # noqa: E501
        """Add relation for CategoryAsset  # noqa: E501

        Add relation for CategoryAsset  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.add_relation_for_category_asset_with_http_info(link, ids, foreign_ids, async_req=True)
        >>> result = thread.get()

        :param link: (required)
        :type link: str
        :param ids: (required)
        :type ids: List[str]
        :param foreign_ids: (required)
        :type foreign_ids: List[str]
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(bool, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'link',
            'ids',
            'foreign_ids'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_relation_for_category_asset" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['link']:
            _path_params['link'] = _params['link']


        # process the query parameters
        _query_params = []
        if _params.get('ids') is not None:  # noqa: E501
            _query_params.append(('ids', _params['ids']))
            _collection_formats['ids'] = 'csv'

        if _params.get('foreign_ids') is not None:  # noqa: E501
            _query_params.append(('foreignIds', _params['foreign_ids']))
            _collection_formats['foreignIds'] = 'csv'

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['Authorization-Token']  # noqa: E501

        _response_types_map = {
            '200': "bool",
            '304': None,
            '400': None,
            '401': None,
            '403': None,
            '404': None,
            '500': None,
        }

        return self.api_client.call_api(
            '/CategoryAsset/{link}/relation', 'POST',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def create_category_asset_item(self, create_category_asset_item_request : CreateCategoryAssetItemRequest, **kwargs) -> CategoryAsset:  # noqa: E501
        """Create a record of the CategoryAsset  # noqa: E501

        Create a record of the CategoryAsset  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.create_category_asset_item(create_category_asset_item_request, async_req=True)
        >>> result = thread.get()

        :param create_category_asset_item_request: (required)
        :type create_category_asset_item_request: CreateCategoryAssetItemRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: CategoryAsset
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the create_category_asset_item_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.create_category_asset_item_with_http_info(create_category_asset_item_request, **kwargs)  # noqa: E501

    @validate_arguments
    def create_category_asset_item_with_http_info(self, create_category_asset_item_request : CreateCategoryAssetItemRequest, **kwargs) -> ApiResponse:  # noqa: E501
        """Create a record of the CategoryAsset  # noqa: E501

        Create a record of the CategoryAsset  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.create_category_asset_item_with_http_info(create_category_asset_item_request, async_req=True)
        >>> result = thread.get()

        :param create_category_asset_item_request: (required)
        :type create_category_asset_item_request: CreateCategoryAssetItemRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(CategoryAsset, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'create_category_asset_item_request'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_category_asset_item" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['create_category_asset_item_request'] is not None:
            _body_params = _params['create_category_asset_item_request']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['Authorization-Token']  # noqa: E501

        _response_types_map = {
            '200': "CategoryAsset",
            '304': None,
            '400': None,
            '401': None,
            '403': None,
            '404': None,
            '500': None,
        }

        return self.api_client.call_api(
            '/CategoryAsset', 'POST',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def delete_category_asset_item(self, id : StrictStr, **kwargs) -> bool:  # noqa: E501
        """Delete a record of the CategoryAsset  # noqa: E501

        Delete a record of the CategoryAsset  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.delete_category_asset_item(id, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: bool
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the delete_category_asset_item_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.delete_category_asset_item_with_http_info(id, **kwargs)  # noqa: E501

    @validate_arguments
    def delete_category_asset_item_with_http_info(self, id : StrictStr, **kwargs) -> ApiResponse:  # noqa: E501
        """Delete a record of the CategoryAsset  # noqa: E501

        Delete a record of the CategoryAsset  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.delete_category_asset_item_with_http_info(id, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(bool, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'id'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_category_asset_item" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['id']:
            _path_params['id'] = _params['id']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['Authorization-Token']  # noqa: E501

        _response_types_map = {
            '200': "bool",
            '304': None,
            '400': None,
            '401': None,
            '403': None,
            '404': None,
            '500': None,
        }

        return self.api_client.call_api(
            '/CategoryAsset/{id}', 'DELETE',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def follow_category_asset(self, id : StrictStr, **kwargs) -> FollowAccount200Response:  # noqa: E501
        """Follow the CategoryAsset stream  # noqa: E501

        Follow the CategoryAsset stream  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.follow_category_asset(id, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: FollowAccount200Response
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the follow_category_asset_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.follow_category_asset_with_http_info(id, **kwargs)  # noqa: E501

    @validate_arguments
    def follow_category_asset_with_http_info(self, id : StrictStr, **kwargs) -> ApiResponse:  # noqa: E501
        """Follow the CategoryAsset stream  # noqa: E501

        Follow the CategoryAsset stream  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.follow_category_asset_with_http_info(id, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(FollowAccount200Response, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'id'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method follow_category_asset" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['id']:
            _path_params['id'] = _params['id']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['Authorization-Token']  # noqa: E501

        _response_types_map = {
            '200': "FollowAccount200Response",
            '304': None,
            '400': None,
            '401': None,
            '403': None,
            '404': None,
            '500': None,
        }

        return self.api_client.call_api(
            '/CategoryAsset/{id}/subscription', 'PUT',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def get_category_asset_item(self, id : StrictStr, language : Annotated[Optional[StrictStr], Field(description="Set this parameter for data to be returned for a specified language")] = None, **kwargs) -> CategoryAsset:  # noqa: E501
        """Returns a record of the CategoryAsset  # noqa: E501

        Returns a record of the CategoryAsset  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_category_asset_item(id, language, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param language: Set this parameter for data to be returned for a specified language
        :type language: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: CategoryAsset
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the get_category_asset_item_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.get_category_asset_item_with_http_info(id, language, **kwargs)  # noqa: E501

    @validate_arguments
    def get_category_asset_item_with_http_info(self, id : StrictStr, language : Annotated[Optional[StrictStr], Field(description="Set this parameter for data to be returned for a specified language")] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """Returns a record of the CategoryAsset  # noqa: E501

        Returns a record of the CategoryAsset  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_category_asset_item_with_http_info(id, language, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param language: Set this parameter for data to be returned for a specified language
        :type language: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(CategoryAsset, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'id',
            'language'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_category_asset_item" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['id']:
            _path_params['id'] = _params['id']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        if _params['language']:
            _header_params['language'] = _params['language']

        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['Authorization-Token']  # noqa: E501

        _response_types_map = {
            '200': "CategoryAsset",
            '304': None,
            '400': None,
            '401': None,
            '403': None,
            '404': None,
            '500': None,
        }

        return self.api_client.call_api(
            '/CategoryAsset/{id}', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def get_linked_items_for_category_asset_item(self, id : StrictStr, link : StrictStr, language : Annotated[Optional[StrictStr], Field(description="Set this parameter for data to be returned for a specified language")] = None, **kwargs) -> GetLinkedItemsForAccountItem200Response:  # noqa: E501
        """Returns linked entities for the CategoryAsset  # noqa: E501

        Returns linked entities for the CategoryAsset  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_linked_items_for_category_asset_item(id, link, language, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param link: (required)
        :type link: str
        :param language: Set this parameter for data to be returned for a specified language
        :type language: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: GetLinkedItemsForAccountItem200Response
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the get_linked_items_for_category_asset_item_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.get_linked_items_for_category_asset_item_with_http_info(id, link, language, **kwargs)  # noqa: E501

    @validate_arguments
    def get_linked_items_for_category_asset_item_with_http_info(self, id : StrictStr, link : StrictStr, language : Annotated[Optional[StrictStr], Field(description="Set this parameter for data to be returned for a specified language")] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """Returns linked entities for the CategoryAsset  # noqa: E501

        Returns linked entities for the CategoryAsset  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_linked_items_for_category_asset_item_with_http_info(id, link, language, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param link: (required)
        :type link: str
        :param language: Set this parameter for data to be returned for a specified language
        :type language: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(GetLinkedItemsForAccountItem200Response, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'id',
            'link',
            'language'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_linked_items_for_category_asset_item" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['id']:
            _path_params['id'] = _params['id']

        if _params['link']:
            _path_params['link'] = _params['link']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        if _params['language']:
            _header_params['language'] = _params['language']

        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['Authorization-Token']  # noqa: E501

        _response_types_map = {
            '200': "GetLinkedItemsForAccountItem200Response",
            '304': None,
            '400': None,
            '401': None,
            '403': None,
            '404': None,
            '500': None,
        }

        return self.api_client.call_api(
            '/CategoryAsset/{id}/{link}', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def get_list_of_category_asset_items(self, language : Annotated[Optional[StrictStr], Field(description="Set this parameter for data to be returned for a specified language")] = None, select : Annotated[Optional[StrictStr], Field(description="Available fields: asset, assetId, assetName, asset_afterSaveMessage, asset_colorDepth, asset_colorSpace, asset_createdAt, asset_createdBy, asset_createdById, asset_createdByName, asset_description, asset_descriptionDeDe, asset_fileId, asset_fileName, asset_filePathsData, asset_filterCreateImportJob, asset_filterUpdateImportJob, asset_hasChildren, asset_height, asset_hierarchyRoute, asset_hierarchySortOrder, asset_icon, asset_inheritedFields, asset_isActive, asset_isRoot, asset_library, asset_libraryId, asset_libraryName, asset_modifiedAt, asset_modifiedBy, asset_modifiedById, asset_modifiedByName, asset_name, asset_orientation, asset_preview, asset_private, asset_size, asset_sortOrder, asset_tags, asset_type, asset_url, asset_width, category, categoryId, categoryName, category__position, category__target, category_assignedUser, category_assignedUserId, category_assignedUserName, category_categoryParent, category_categoryParentId, category_categoryParentName, category_categoryRoute, category_categoryRouteName, category_childrenCount, category_code, category_createdAt, category_createdBy, category_createdById, category_createdByName, category_description, category_descriptionDeDe, category_filterCreateImportJob, category_filterUpdateImportJob, category_hasChildren, category_isActive, category_mainImageId, category_mainImageName, category_mainImagePathsData, category_modifiedAt, category_modifiedBy, category_modifiedById, category_modifiedByName, category_name, category_nameDeDe, category_ownerUser, category_ownerUserId, category_ownerUserName, category_sortOrder, category_sorting, createdAt, createdBy, createdById, createdByName, deleted, fileId, fileName, filePathsData, filterCreateImportJob, filterUpdateImportJob, icon, id, isInherited, isMainImage, modifiedAt, modifiedBy, modifiedById, modifiedByName, name, preview, sorting, tags")] = None, where : Annotated[Optional[conlist(Dict[str, Any])], Field(description="There are a lot of filter types supported. You can learn all of them if you trace what's requested by Atro UI in the network tab in your browser console (press F12 key to open the console).")] = None, offset : Optional[StrictInt] = None, max_size : Optional[StrictInt] = None, sort_by : Optional[StrictStr] = None, asc : Optional[StrictBool] = None, **kwargs) -> GetListOfCategoryAssetItems200Response:  # noqa: E501
        """Returns a collection of CategoryAsset records  # noqa: E501

        Returns a collection of CategoryAsset records  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_list_of_category_asset_items(language, select, where, offset, max_size, sort_by, asc, async_req=True)
        >>> result = thread.get()

        :param language: Set this parameter for data to be returned for a specified language
        :type language: str
        :param select: Available fields: asset, assetId, assetName, asset_afterSaveMessage, asset_colorDepth, asset_colorSpace, asset_createdAt, asset_createdBy, asset_createdById, asset_createdByName, asset_description, asset_descriptionDeDe, asset_fileId, asset_fileName, asset_filePathsData, asset_filterCreateImportJob, asset_filterUpdateImportJob, asset_hasChildren, asset_height, asset_hierarchyRoute, asset_hierarchySortOrder, asset_icon, asset_inheritedFields, asset_isActive, asset_isRoot, asset_library, asset_libraryId, asset_libraryName, asset_modifiedAt, asset_modifiedBy, asset_modifiedById, asset_modifiedByName, asset_name, asset_orientation, asset_preview, asset_private, asset_size, asset_sortOrder, asset_tags, asset_type, asset_url, asset_width, category, categoryId, categoryName, category__position, category__target, category_assignedUser, category_assignedUserId, category_assignedUserName, category_categoryParent, category_categoryParentId, category_categoryParentName, category_categoryRoute, category_categoryRouteName, category_childrenCount, category_code, category_createdAt, category_createdBy, category_createdById, category_createdByName, category_description, category_descriptionDeDe, category_filterCreateImportJob, category_filterUpdateImportJob, category_hasChildren, category_isActive, category_mainImageId, category_mainImageName, category_mainImagePathsData, category_modifiedAt, category_modifiedBy, category_modifiedById, category_modifiedByName, category_name, category_nameDeDe, category_ownerUser, category_ownerUserId, category_ownerUserName, category_sortOrder, category_sorting, createdAt, createdBy, createdById, createdByName, deleted, fileId, fileName, filePathsData, filterCreateImportJob, filterUpdateImportJob, icon, id, isInherited, isMainImage, modifiedAt, modifiedBy, modifiedById, modifiedByName, name, preview, sorting, tags
        :type select: str
        :param where: There are a lot of filter types supported. You can learn all of them if you trace what's requested by Atro UI in the network tab in your browser console (press F12 key to open the console).
        :type where: List[object]
        :param offset:
        :type offset: int
        :param max_size:
        :type max_size: int
        :param sort_by:
        :type sort_by: str
        :param asc:
        :type asc: bool
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: GetListOfCategoryAssetItems200Response
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the get_list_of_category_asset_items_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.get_list_of_category_asset_items_with_http_info(language, select, where, offset, max_size, sort_by, asc, **kwargs)  # noqa: E501

    @validate_arguments
    def get_list_of_category_asset_items_with_http_info(self, language : Annotated[Optional[StrictStr], Field(description="Set this parameter for data to be returned for a specified language")] = None, select : Annotated[Optional[StrictStr], Field(description="Available fields: asset, assetId, assetName, asset_afterSaveMessage, asset_colorDepth, asset_colorSpace, asset_createdAt, asset_createdBy, asset_createdById, asset_createdByName, asset_description, asset_descriptionDeDe, asset_fileId, asset_fileName, asset_filePathsData, asset_filterCreateImportJob, asset_filterUpdateImportJob, asset_hasChildren, asset_height, asset_hierarchyRoute, asset_hierarchySortOrder, asset_icon, asset_inheritedFields, asset_isActive, asset_isRoot, asset_library, asset_libraryId, asset_libraryName, asset_modifiedAt, asset_modifiedBy, asset_modifiedById, asset_modifiedByName, asset_name, asset_orientation, asset_preview, asset_private, asset_size, asset_sortOrder, asset_tags, asset_type, asset_url, asset_width, category, categoryId, categoryName, category__position, category__target, category_assignedUser, category_assignedUserId, category_assignedUserName, category_categoryParent, category_categoryParentId, category_categoryParentName, category_categoryRoute, category_categoryRouteName, category_childrenCount, category_code, category_createdAt, category_createdBy, category_createdById, category_createdByName, category_description, category_descriptionDeDe, category_filterCreateImportJob, category_filterUpdateImportJob, category_hasChildren, category_isActive, category_mainImageId, category_mainImageName, category_mainImagePathsData, category_modifiedAt, category_modifiedBy, category_modifiedById, category_modifiedByName, category_name, category_nameDeDe, category_ownerUser, category_ownerUserId, category_ownerUserName, category_sortOrder, category_sorting, createdAt, createdBy, createdById, createdByName, deleted, fileId, fileName, filePathsData, filterCreateImportJob, filterUpdateImportJob, icon, id, isInherited, isMainImage, modifiedAt, modifiedBy, modifiedById, modifiedByName, name, preview, sorting, tags")] = None, where : Annotated[Optional[conlist(Dict[str, Any])], Field(description="There are a lot of filter types supported. You can learn all of them if you trace what's requested by Atro UI in the network tab in your browser console (press F12 key to open the console).")] = None, offset : Optional[StrictInt] = None, max_size : Optional[StrictInt] = None, sort_by : Optional[StrictStr] = None, asc : Optional[StrictBool] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """Returns a collection of CategoryAsset records  # noqa: E501

        Returns a collection of CategoryAsset records  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_list_of_category_asset_items_with_http_info(language, select, where, offset, max_size, sort_by, asc, async_req=True)
        >>> result = thread.get()

        :param language: Set this parameter for data to be returned for a specified language
        :type language: str
        :param select: Available fields: asset, assetId, assetName, asset_afterSaveMessage, asset_colorDepth, asset_colorSpace, asset_createdAt, asset_createdBy, asset_createdById, asset_createdByName, asset_description, asset_descriptionDeDe, asset_fileId, asset_fileName, asset_filePathsData, asset_filterCreateImportJob, asset_filterUpdateImportJob, asset_hasChildren, asset_height, asset_hierarchyRoute, asset_hierarchySortOrder, asset_icon, asset_inheritedFields, asset_isActive, asset_isRoot, asset_library, asset_libraryId, asset_libraryName, asset_modifiedAt, asset_modifiedBy, asset_modifiedById, asset_modifiedByName, asset_name, asset_orientation, asset_preview, asset_private, asset_size, asset_sortOrder, asset_tags, asset_type, asset_url, asset_width, category, categoryId, categoryName, category__position, category__target, category_assignedUser, category_assignedUserId, category_assignedUserName, category_categoryParent, category_categoryParentId, category_categoryParentName, category_categoryRoute, category_categoryRouteName, category_childrenCount, category_code, category_createdAt, category_createdBy, category_createdById, category_createdByName, category_description, category_descriptionDeDe, category_filterCreateImportJob, category_filterUpdateImportJob, category_hasChildren, category_isActive, category_mainImageId, category_mainImageName, category_mainImagePathsData, category_modifiedAt, category_modifiedBy, category_modifiedById, category_modifiedByName, category_name, category_nameDeDe, category_ownerUser, category_ownerUserId, category_ownerUserName, category_sortOrder, category_sorting, createdAt, createdBy, createdById, createdByName, deleted, fileId, fileName, filePathsData, filterCreateImportJob, filterUpdateImportJob, icon, id, isInherited, isMainImage, modifiedAt, modifiedBy, modifiedById, modifiedByName, name, preview, sorting, tags
        :type select: str
        :param where: There are a lot of filter types supported. You can learn all of them if you trace what's requested by Atro UI in the network tab in your browser console (press F12 key to open the console).
        :type where: List[object]
        :param offset:
        :type offset: int
        :param max_size:
        :type max_size: int
        :param sort_by:
        :type sort_by: str
        :param asc:
        :type asc: bool
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(GetListOfCategoryAssetItems200Response, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'language',
            'select',
            'where',
            'offset',
            'max_size',
            'sort_by',
            'asc'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_list_of_category_asset_items" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('select') is not None:  # noqa: E501
            _query_params.append(('select', _params['select']))

        if _params.get('where') is not None:  # noqa: E501
            _query_params.append(('where', _params['where']))
            _collection_formats['where'] = 'csv'

        if _params.get('offset') is not None:  # noqa: E501
            _query_params.append(('offset', _params['offset']))

        if _params.get('max_size') is not None:  # noqa: E501
            _query_params.append(('maxSize', _params['max_size']))

        if _params.get('sort_by') is not None:  # noqa: E501
            _query_params.append(('sortBy', _params['sort_by']))

        if _params.get('asc') is not None:  # noqa: E501
            _query_params.append(('asc', _params['asc']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        if _params['language']:
            _header_params['language'] = _params['language']

        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['Authorization-Token']  # noqa: E501

        _response_types_map = {
            '200': "GetListOfCategoryAssetItems200Response",
            '304': None,
            '400': None,
            '401': None,
            '403': None,
            '404': None,
            '500': None,
        }

        return self.api_client.call_api(
            '/CategoryAsset', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def link_category_asset(self, id : StrictStr, link : StrictStr, link_account_request : LinkAccountRequest, **kwargs) -> bool:  # noqa: E501
        """Link CategoryAsset to Entities  # noqa: E501

        Link CategoryAsset to Entities  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.link_category_asset(id, link, link_account_request, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param link: (required)
        :type link: str
        :param link_account_request: (required)
        :type link_account_request: LinkAccountRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: bool
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the link_category_asset_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.link_category_asset_with_http_info(id, link, link_account_request, **kwargs)  # noqa: E501

    @validate_arguments
    def link_category_asset_with_http_info(self, id : StrictStr, link : StrictStr, link_account_request : LinkAccountRequest, **kwargs) -> ApiResponse:  # noqa: E501
        """Link CategoryAsset to Entities  # noqa: E501

        Link CategoryAsset to Entities  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.link_category_asset_with_http_info(id, link, link_account_request, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param link: (required)
        :type link: str
        :param link_account_request: (required)
        :type link_account_request: LinkAccountRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(bool, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'id',
            'link',
            'link_account_request'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method link_category_asset" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['id']:
            _path_params['id'] = _params['id']

        if _params['link']:
            _path_params['link'] = _params['link']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['link_account_request'] is not None:
            _body_params = _params['link_account_request']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['Authorization-Token']  # noqa: E501

        _response_types_map = {
            '200': "bool",
            '304': None,
            '400': None,
            '401': None,
            '403': None,
            '404': None,
            '500': None,
        }

        return self.api_client.call_api(
            '/CategoryAsset/{id}/{link}', 'POST',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def mass_delete_category_asset(self, link_account_request : LinkAccountRequest, **kwargs) -> bool:  # noqa: E501
        """Mass delete of CategoryAsset data  # noqa: E501

        Mass delete of CategoryAsset data  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.mass_delete_category_asset(link_account_request, async_req=True)
        >>> result = thread.get()

        :param link_account_request: (required)
        :type link_account_request: LinkAccountRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: bool
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the mass_delete_category_asset_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.mass_delete_category_asset_with_http_info(link_account_request, **kwargs)  # noqa: E501

    @validate_arguments
    def mass_delete_category_asset_with_http_info(self, link_account_request : LinkAccountRequest, **kwargs) -> ApiResponse:  # noqa: E501
        """Mass delete of CategoryAsset data  # noqa: E501

        Mass delete of CategoryAsset data  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.mass_delete_category_asset_with_http_info(link_account_request, async_req=True)
        >>> result = thread.get()

        :param link_account_request: (required)
        :type link_account_request: LinkAccountRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(bool, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'link_account_request'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method mass_delete_category_asset" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['link_account_request'] is not None:
            _body_params = _params['link_account_request']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['Authorization-Token']  # noqa: E501

        _response_types_map = {
            '200': "bool",
            '304': None,
            '400': None,
            '401': None,
            '403': None,
            '404': None,
            '500': None,
        }

        return self.api_client.call_api(
            '/CategoryAsset/action/massDelete', 'POST',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def mass_update_category_asset(self, mass_update_account_request : MassUpdateAccountRequest, **kwargs) -> bool:  # noqa: E501
        """Mass update of CategoryAsset data  # noqa: E501

        Mass update of CategoryAsset data  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.mass_update_category_asset(mass_update_account_request, async_req=True)
        >>> result = thread.get()

        :param mass_update_account_request: (required)
        :type mass_update_account_request: MassUpdateAccountRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: bool
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the mass_update_category_asset_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.mass_update_category_asset_with_http_info(mass_update_account_request, **kwargs)  # noqa: E501

    @validate_arguments
    def mass_update_category_asset_with_http_info(self, mass_update_account_request : MassUpdateAccountRequest, **kwargs) -> ApiResponse:  # noqa: E501
        """Mass update of CategoryAsset data  # noqa: E501

        Mass update of CategoryAsset data  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.mass_update_category_asset_with_http_info(mass_update_account_request, async_req=True)
        >>> result = thread.get()

        :param mass_update_account_request: (required)
        :type mass_update_account_request: MassUpdateAccountRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(bool, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'mass_update_account_request'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method mass_update_category_asset" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['mass_update_account_request'] is not None:
            _body_params = _params['mass_update_account_request']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['Authorization-Token']  # noqa: E501

        _response_types_map = {
            '200': "bool",
            '304': None,
            '400': None,
            '401': None,
            '403': None,
            '404': None,
            '500': None,
        }

        return self.api_client.call_api(
            '/CategoryAsset/action/massUpdate', 'PUT',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def remove_relation_for_category_asset(self, link : StrictStr, ids : conlist(StrictStr), foreign_ids : conlist(StrictStr), **kwargs) -> bool:  # noqa: E501
        """Remove relation for CategoryAsset  # noqa: E501

        Remove relation for CategoryAsset  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.remove_relation_for_category_asset(link, ids, foreign_ids, async_req=True)
        >>> result = thread.get()

        :param link: (required)
        :type link: str
        :param ids: (required)
        :type ids: List[str]
        :param foreign_ids: (required)
        :type foreign_ids: List[str]
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: bool
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the remove_relation_for_category_asset_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.remove_relation_for_category_asset_with_http_info(link, ids, foreign_ids, **kwargs)  # noqa: E501

    @validate_arguments
    def remove_relation_for_category_asset_with_http_info(self, link : StrictStr, ids : conlist(StrictStr), foreign_ids : conlist(StrictStr), **kwargs) -> ApiResponse:  # noqa: E501
        """Remove relation for CategoryAsset  # noqa: E501

        Remove relation for CategoryAsset  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.remove_relation_for_category_asset_with_http_info(link, ids, foreign_ids, async_req=True)
        >>> result = thread.get()

        :param link: (required)
        :type link: str
        :param ids: (required)
        :type ids: List[str]
        :param foreign_ids: (required)
        :type foreign_ids: List[str]
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(bool, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'link',
            'ids',
            'foreign_ids'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method remove_relation_for_category_asset" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['link']:
            _path_params['link'] = _params['link']


        # process the query parameters
        _query_params = []
        if _params.get('ids') is not None:  # noqa: E501
            _query_params.append(('ids', _params['ids']))
            _collection_formats['ids'] = 'csv'

        if _params.get('foreign_ids') is not None:  # noqa: E501
            _query_params.append(('foreignIds', _params['foreign_ids']))
            _collection_formats['foreignIds'] = 'csv'

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['Authorization-Token']  # noqa: E501

        _response_types_map = {
            '200': "bool",
            '304': None,
            '400': None,
            '401': None,
            '403': None,
            '404': None,
            '500': None,
        }

        return self.api_client.call_api(
            '/CategoryAsset/{link}/relation', 'DELETE',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def unfollow_category_asset(self, id : StrictStr, **kwargs) -> bool:  # noqa: E501
        """Unfollow the CategoryAsset stream  # noqa: E501

        Unfollow the CategoryAsset stream  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.unfollow_category_asset(id, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: bool
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the unfollow_category_asset_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.unfollow_category_asset_with_http_info(id, **kwargs)  # noqa: E501

    @validate_arguments
    def unfollow_category_asset_with_http_info(self, id : StrictStr, **kwargs) -> ApiResponse:  # noqa: E501
        """Unfollow the CategoryAsset stream  # noqa: E501

        Unfollow the CategoryAsset stream  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.unfollow_category_asset_with_http_info(id, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(bool, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'id'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method unfollow_category_asset" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['id']:
            _path_params['id'] = _params['id']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['Authorization-Token']  # noqa: E501

        _response_types_map = {
            '200': "bool",
            '304': None,
            '400': None,
            '401': None,
            '403': None,
            '404': None,
            '500': None,
        }

        return self.api_client.call_api(
            '/CategoryAsset/{id}/subscription', 'DELETE',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def unlink_category_asset(self, id : StrictStr, link : StrictStr, ids : conlist(StrictStr), **kwargs) -> bool:  # noqa: E501
        """Unlink CategoryAsset from Entities  # noqa: E501

        Unlink CategoryAsset from Entities  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.unlink_category_asset(id, link, ids, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param link: (required)
        :type link: str
        :param ids: (required)
        :type ids: List[str]
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: bool
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the unlink_category_asset_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.unlink_category_asset_with_http_info(id, link, ids, **kwargs)  # noqa: E501

    @validate_arguments
    def unlink_category_asset_with_http_info(self, id : StrictStr, link : StrictStr, ids : conlist(StrictStr), **kwargs) -> ApiResponse:  # noqa: E501
        """Unlink CategoryAsset from Entities  # noqa: E501

        Unlink CategoryAsset from Entities  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.unlink_category_asset_with_http_info(id, link, ids, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param link: (required)
        :type link: str
        :param ids: (required)
        :type ids: List[str]
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(bool, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'id',
            'link',
            'ids'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method unlink_category_asset" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['id']:
            _path_params['id'] = _params['id']

        if _params['link']:
            _path_params['link'] = _params['link']


        # process the query parameters
        _query_params = []
        if _params.get('ids') is not None:  # noqa: E501
            _query_params.append(('ids', _params['ids']))
            _collection_formats['ids'] = 'csv'

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['Authorization-Token']  # noqa: E501

        _response_types_map = {
            '200': "bool",
            '304': None,
            '400': None,
            '401': None,
            '403': None,
            '404': None,
            '500': None,
        }

        return self.api_client.call_api(
            '/CategoryAsset/{id}/{link}', 'DELETE',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def update_category_asset_item(self, id : StrictStr, create_category_asset_item_request : CreateCategoryAssetItemRequest, **kwargs) -> CategoryAsset:  # noqa: E501
        """Update a record of the CategoryAsset  # noqa: E501

        Update a record of the CategoryAsset  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.update_category_asset_item(id, create_category_asset_item_request, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param create_category_asset_item_request: (required)
        :type create_category_asset_item_request: CreateCategoryAssetItemRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: CategoryAsset
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the update_category_asset_item_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.update_category_asset_item_with_http_info(id, create_category_asset_item_request, **kwargs)  # noqa: E501

    @validate_arguments
    def update_category_asset_item_with_http_info(self, id : StrictStr, create_category_asset_item_request : CreateCategoryAssetItemRequest, **kwargs) -> ApiResponse:  # noqa: E501
        """Update a record of the CategoryAsset  # noqa: E501

        Update a record of the CategoryAsset  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.update_category_asset_item_with_http_info(id, create_category_asset_item_request, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param create_category_asset_item_request: (required)
        :type create_category_asset_item_request: CreateCategoryAssetItemRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(CategoryAsset, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'id',
            'create_category_asset_item_request'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_category_asset_item" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['id']:
            _path_params['id'] = _params['id']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['create_category_asset_item_request'] is not None:
            _body_params = _params['create_category_asset_item_request']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['Authorization-Token']  # noqa: E501

        _response_types_map = {
            '200': "CategoryAsset",
            '304': None,
            '400': None,
            '401': None,
            '403': None,
            '404': None,
            '500': None,
        }

        return self.api_client.call_api(
            '/CategoryAsset/{id}', 'PUT',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))
