# coding: utf-8

"""
    AtroCore REST API documentation

    This is a REST API documentation for AtroCore data platform and its modules (AtroPIM, AtroDAM and others), which is based on [OpenAPI (Swagger) Specification](https://swagger.io/specification/). You can generate your client [here](https://openapi-generator.tech/docs/generators).<br><br><h3>Video tutorials:</h3><ul><li>[How to authorize?](https://youtu.be/GWfNRvCswXg)</li><li>[How to select specific fields?](https://youtu.be/i7o0aENuyuY)</li><li>[How to filter data records?](https://youtu.be/irgWkN4wlkM)</li></ul>

    The version of the OpenAPI document: 1.6.55
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import re  # noqa: F401
import io
import warnings

from pydantic import validate_arguments, ValidationError

from typing_extensions import Annotated
from pydantic import Field, StrictBool, StrictInt, StrictStr, conlist

from typing import Any, Dict, Optional

from clientapi_atrocore.models.create_product_attribute_value_item_request import CreateProductAttributeValueItemRequest
from clientapi_atrocore.models.follow_account200_response import FollowAccount200Response
from clientapi_atrocore.models.get_linked_items_for_account_item200_response import GetLinkedItemsForAccountItem200Response
from clientapi_atrocore.models.get_list_of_product_attribute_value_items200_response import GetListOfProductAttributeValueItems200Response
from clientapi_atrocore.models.link_account_request import LinkAccountRequest
from clientapi_atrocore.models.mass_update_account_request import MassUpdateAccountRequest
from clientapi_atrocore.models.product_attribute_value import ProductAttributeValue

from clientapi_atrocore.api_client import ApiClient
from clientapi_atrocore.api_response import ApiResponse
from clientapi_atrocore.exceptions import (  # noqa: F401
    ApiTypeError,
    ApiValueError
)


class ProductAttributeValueApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client

    @validate_arguments
    def add_relation_for_product_attribute_value(self, link : StrictStr, ids : conlist(StrictStr), foreign_ids : conlist(StrictStr), **kwargs) -> bool:  # noqa: E501
        """Add relation for ProductAttributeValue  # noqa: E501

        Add relation for ProductAttributeValue  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.add_relation_for_product_attribute_value(link, ids, foreign_ids, async_req=True)
        >>> result = thread.get()

        :param link: (required)
        :type link: str
        :param ids: (required)
        :type ids: List[str]
        :param foreign_ids: (required)
        :type foreign_ids: List[str]
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: bool
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the add_relation_for_product_attribute_value_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.add_relation_for_product_attribute_value_with_http_info(link, ids, foreign_ids, **kwargs)  # noqa: E501

    @validate_arguments
    def add_relation_for_product_attribute_value_with_http_info(self, link : StrictStr, ids : conlist(StrictStr), foreign_ids : conlist(StrictStr), **kwargs) -> ApiResponse:  # noqa: E501
        """Add relation for ProductAttributeValue  # noqa: E501

        Add relation for ProductAttributeValue  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.add_relation_for_product_attribute_value_with_http_info(link, ids, foreign_ids, async_req=True)
        >>> result = thread.get()

        :param link: (required)
        :type link: str
        :param ids: (required)
        :type ids: List[str]
        :param foreign_ids: (required)
        :type foreign_ids: List[str]
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(bool, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'link',
            'ids',
            'foreign_ids'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_relation_for_product_attribute_value" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['link']:
            _path_params['link'] = _params['link']


        # process the query parameters
        _query_params = []
        if _params.get('ids') is not None:  # noqa: E501
            _query_params.append(('ids', _params['ids']))
            _collection_formats['ids'] = 'csv'

        if _params.get('foreign_ids') is not None:  # noqa: E501
            _query_params.append(('foreignIds', _params['foreign_ids']))
            _collection_formats['foreignIds'] = 'csv'

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['Authorization-Token']  # noqa: E501

        _response_types_map = {
            '200': "bool",
            '304': None,
            '400': None,
            '401': None,
            '403': None,
            '404': None,
            '500': None,
        }

        return self.api_client.call_api(
            '/ProductAttributeValue/{link}/relation', 'POST',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def create_product_attribute_value_item(self, create_product_attribute_value_item_request : CreateProductAttributeValueItemRequest, **kwargs) -> ProductAttributeValue:  # noqa: E501
        """Create a record of the ProductAttributeValue  # noqa: E501

        Create a record of the ProductAttributeValue  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.create_product_attribute_value_item(create_product_attribute_value_item_request, async_req=True)
        >>> result = thread.get()

        :param create_product_attribute_value_item_request: (required)
        :type create_product_attribute_value_item_request: CreateProductAttributeValueItemRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: ProductAttributeValue
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the create_product_attribute_value_item_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.create_product_attribute_value_item_with_http_info(create_product_attribute_value_item_request, **kwargs)  # noqa: E501

    @validate_arguments
    def create_product_attribute_value_item_with_http_info(self, create_product_attribute_value_item_request : CreateProductAttributeValueItemRequest, **kwargs) -> ApiResponse:  # noqa: E501
        """Create a record of the ProductAttributeValue  # noqa: E501

        Create a record of the ProductAttributeValue  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.create_product_attribute_value_item_with_http_info(create_product_attribute_value_item_request, async_req=True)
        >>> result = thread.get()

        :param create_product_attribute_value_item_request: (required)
        :type create_product_attribute_value_item_request: CreateProductAttributeValueItemRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(ProductAttributeValue, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'create_product_attribute_value_item_request'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_product_attribute_value_item" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['create_product_attribute_value_item_request'] is not None:
            _body_params = _params['create_product_attribute_value_item_request']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['Authorization-Token']  # noqa: E501

        _response_types_map = {
            '200': "ProductAttributeValue",
            '304': None,
            '400': None,
            '401': None,
            '403': None,
            '404': None,
            '500': None,
        }

        return self.api_client.call_api(
            '/ProductAttributeValue', 'POST',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def delete_product_attribute_value_item(self, id : StrictStr, **kwargs) -> bool:  # noqa: E501
        """Delete a record of the ProductAttributeValue  # noqa: E501

        Delete a record of the ProductAttributeValue  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.delete_product_attribute_value_item(id, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: bool
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the delete_product_attribute_value_item_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.delete_product_attribute_value_item_with_http_info(id, **kwargs)  # noqa: E501

    @validate_arguments
    def delete_product_attribute_value_item_with_http_info(self, id : StrictStr, **kwargs) -> ApiResponse:  # noqa: E501
        """Delete a record of the ProductAttributeValue  # noqa: E501

        Delete a record of the ProductAttributeValue  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.delete_product_attribute_value_item_with_http_info(id, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(bool, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'id'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_product_attribute_value_item" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['id']:
            _path_params['id'] = _params['id']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['Authorization-Token']  # noqa: E501

        _response_types_map = {
            '200': "bool",
            '304': None,
            '400': None,
            '401': None,
            '403': None,
            '404': None,
            '500': None,
        }

        return self.api_client.call_api(
            '/ProductAttributeValue/{id}', 'DELETE',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def follow_product_attribute_value(self, id : StrictStr, **kwargs) -> FollowAccount200Response:  # noqa: E501
        """Follow the ProductAttributeValue stream  # noqa: E501

        Follow the ProductAttributeValue stream  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.follow_product_attribute_value(id, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: FollowAccount200Response
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the follow_product_attribute_value_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.follow_product_attribute_value_with_http_info(id, **kwargs)  # noqa: E501

    @validate_arguments
    def follow_product_attribute_value_with_http_info(self, id : StrictStr, **kwargs) -> ApiResponse:  # noqa: E501
        """Follow the ProductAttributeValue stream  # noqa: E501

        Follow the ProductAttributeValue stream  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.follow_product_attribute_value_with_http_info(id, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(FollowAccount200Response, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'id'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method follow_product_attribute_value" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['id']:
            _path_params['id'] = _params['id']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['Authorization-Token']  # noqa: E501

        _response_types_map = {
            '200': "FollowAccount200Response",
            '304': None,
            '400': None,
            '401': None,
            '403': None,
            '404': None,
            '500': None,
        }

        return self.api_client.call_api(
            '/ProductAttributeValue/{id}/subscription', 'PUT',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def get_linked_items_for_product_attribute_value_item(self, id : StrictStr, link : StrictStr, language : Annotated[Optional[StrictStr], Field(description="Set this parameter for data to be returned for a specified language")] = None, **kwargs) -> GetLinkedItemsForAccountItem200Response:  # noqa: E501
        """Returns linked entities for the ProductAttributeValue  # noqa: E501

        Returns linked entities for the ProductAttributeValue  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_linked_items_for_product_attribute_value_item(id, link, language, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param link: (required)
        :type link: str
        :param language: Set this parameter for data to be returned for a specified language
        :type language: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: GetLinkedItemsForAccountItem200Response
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the get_linked_items_for_product_attribute_value_item_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.get_linked_items_for_product_attribute_value_item_with_http_info(id, link, language, **kwargs)  # noqa: E501

    @validate_arguments
    def get_linked_items_for_product_attribute_value_item_with_http_info(self, id : StrictStr, link : StrictStr, language : Annotated[Optional[StrictStr], Field(description="Set this parameter for data to be returned for a specified language")] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """Returns linked entities for the ProductAttributeValue  # noqa: E501

        Returns linked entities for the ProductAttributeValue  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_linked_items_for_product_attribute_value_item_with_http_info(id, link, language, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param link: (required)
        :type link: str
        :param language: Set this parameter for data to be returned for a specified language
        :type language: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(GetLinkedItemsForAccountItem200Response, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'id',
            'link',
            'language'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_linked_items_for_product_attribute_value_item" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['id']:
            _path_params['id'] = _params['id']

        if _params['link']:
            _path_params['link'] = _params['link']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        if _params['language']:
            _header_params['language'] = _params['language']

        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['Authorization-Token']  # noqa: E501

        _response_types_map = {
            '200': "GetLinkedItemsForAccountItem200Response",
            '304': None,
            '400': None,
            '401': None,
            '403': None,
            '404': None,
            '500': None,
        }

        return self.api_client.call_api(
            '/ProductAttributeValue/{id}/{link}', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def get_list_of_product_attribute_value_items(self, language : Annotated[Optional[StrictStr], Field(description="Set this parameter for data to be returned for a specified language")] = None, select : Annotated[Optional[StrictStr], Field(description="Available fields: amountOfDigitsAfterComma, assignedUser, assignedUserId, assignedUserName, attribute, attributeAssetType, attributeCode, attributeEntityType, attributeExtensibleEnumId, attributeGroup, attributeGroupId, attributeGroupName, attributeId, attributeIsMultilang, attributeMeasureId, attributeName, attributeTooltip, attributeType, attribute_amountOfDigitsAfterComma, attribute_assetType, attribute_assignedUser, attribute_assignedUserId, attribute_assignedUserName, attribute_attributeGroup, attribute_attributeGroupId, attribute_attributeGroupName, attribute_attributeTab, attribute_attributeTabId, attribute_attributeTabName, attribute_code, attribute_countBytesInsteadOfCharacters, attribute_createdAt, attribute_createdBy, attribute_createdById, attribute_createdByName, attribute_data, attribute_defaultChannel, attribute_defaultChannelId, attribute_defaultChannelName, attribute_defaultScope, attribute_defaultUnit, attribute_description, attribute_descriptionDeDe, attribute_extensibleEnum, attribute_extensibleEnumId, attribute_extensibleEnumName, attribute_filterCreateImportJob, attribute_filterUpdateImportJob, attribute_hasChildren, attribute_hierarchyRoute, attribute_hierarchySortOrder, attribute_inheritedFields, attribute_isMultilang, attribute_isRequired, attribute_isRoot, attribute_max, attribute_maxLength, attribute_measure, attribute_measureId, attribute_measureName, attribute_min, attribute_modifiedAt, attribute_modifiedBy, attribute_modifiedById, attribute_modifiedByName, attribute_name, attribute_nameDeDe, attribute_ownerUser, attribute_ownerUserId, attribute_ownerUserName, attribute_pattern, attribute_prohibitedEmptyValue, attribute_sortOrder, attribute_sortOrderInAttributeGroup, attribute_sortOrderInProduct, attribute_tooltip, attribute_tooltipDeDe, attribute_type, attribute_unique, attribute_useDisabledTextareaInViewMode, attribute_virtualProductField, boolValue, channel, channelCode, channelId, channelName, countBytesInsteadOfCharacters, createdAt, createdBy, createdById, createdByName, data, dateValue, datetimeValue, deleted, filterCreateImportJob, filterUpdateImportJob, floatValue, floatValue1, icons, id, intValue, intValue1, isInheritAssignedUser, isInheritOwnerUser, isInheritTeams, isInherited, isPavRelationInherited, isPavValueInherited, isRequired, isValueReadOnly, isVariantSpecificAttribute, language, mainLanguageId, max, maxLength, min, modifiedAt, modifiedBy, modifiedById, modifiedByName, name, ownerUser, ownerUserId, ownerUserName, product, productId, productName, product_amount, product_assignedUser, product_assignedUserId, product_assignedUserName, product_brand, product_brandId, product_brandName, product_catalog, product_catalogId, product_catalogName, product_createdAt, product_createdBy, product_createdById, product_createdByName, product_data, product_ean, product_filterCreateImportJob, product_filterUpdateImportJob, product_hasChildren, product_hierarchyRoute, product_hierarchySortOrder, product_inheritedFields, product_isActive, product_isInheritAssignedUser, product_isInheritOwnerUser, product_isInheritTeams, product_isRoot, product_longDescription, product_longDescriptionDeDe, product_mainImageId, product_mainImageName, product_mainImagePathsData, product_modifiedAt, product_modifiedAtExpanded, product_modifiedBy, product_modifiedById, product_modifiedByName, product_mpn, product_name, product_nameDeDe, product_ownerUser, product_ownerUserId, product_ownerUserName, product_packaging, product_packagingId, product_packagingName, product_price, product_priceCurrency, product_productSerie, product_productSerieId, product_productSerieName, product_productStatus, product_scope, product_sku, product_sortOrder, product_sorting, product_tag, product_taskStatus, product_tax, product_taxId, product_taxName, product_uvp, prohibitedEmptyValue, scope, sortOrder, teams, teamsIds, teamsNames, textValue, useDisabledTextareaInViewMode, value, valueAllUnits, valueCurrency, valueFrom, valueId, valueName, valueNames, valueOptionData, valueOptionsData, valuePathsData, valueTo, valueUnit, valueUnitId, varcharValue")] = None, where : Annotated[Optional[conlist(Dict[str, Any])], Field(description="There are a lot of filter types supported. You can learn all of them if you trace what's requested by Atro UI in the network tab in your browser console (press F12 key to open the console).")] = None, offset : Optional[StrictInt] = None, max_size : Optional[StrictInt] = None, sort_by : Optional[StrictStr] = None, asc : Optional[StrictBool] = None, **kwargs) -> GetListOfProductAttributeValueItems200Response:  # noqa: E501
        """Returns a collection of ProductAttributeValue records  # noqa: E501

        Returns a collection of ProductAttributeValue records  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_list_of_product_attribute_value_items(language, select, where, offset, max_size, sort_by, asc, async_req=True)
        >>> result = thread.get()

        :param language: Set this parameter for data to be returned for a specified language
        :type language: str
        :param select: Available fields: amountOfDigitsAfterComma, assignedUser, assignedUserId, assignedUserName, attribute, attributeAssetType, attributeCode, attributeEntityType, attributeExtensibleEnumId, attributeGroup, attributeGroupId, attributeGroupName, attributeId, attributeIsMultilang, attributeMeasureId, attributeName, attributeTooltip, attributeType, attribute_amountOfDigitsAfterComma, attribute_assetType, attribute_assignedUser, attribute_assignedUserId, attribute_assignedUserName, attribute_attributeGroup, attribute_attributeGroupId, attribute_attributeGroupName, attribute_attributeTab, attribute_attributeTabId, attribute_attributeTabName, attribute_code, attribute_countBytesInsteadOfCharacters, attribute_createdAt, attribute_createdBy, attribute_createdById, attribute_createdByName, attribute_data, attribute_defaultChannel, attribute_defaultChannelId, attribute_defaultChannelName, attribute_defaultScope, attribute_defaultUnit, attribute_description, attribute_descriptionDeDe, attribute_extensibleEnum, attribute_extensibleEnumId, attribute_extensibleEnumName, attribute_filterCreateImportJob, attribute_filterUpdateImportJob, attribute_hasChildren, attribute_hierarchyRoute, attribute_hierarchySortOrder, attribute_inheritedFields, attribute_isMultilang, attribute_isRequired, attribute_isRoot, attribute_max, attribute_maxLength, attribute_measure, attribute_measureId, attribute_measureName, attribute_min, attribute_modifiedAt, attribute_modifiedBy, attribute_modifiedById, attribute_modifiedByName, attribute_name, attribute_nameDeDe, attribute_ownerUser, attribute_ownerUserId, attribute_ownerUserName, attribute_pattern, attribute_prohibitedEmptyValue, attribute_sortOrder, attribute_sortOrderInAttributeGroup, attribute_sortOrderInProduct, attribute_tooltip, attribute_tooltipDeDe, attribute_type, attribute_unique, attribute_useDisabledTextareaInViewMode, attribute_virtualProductField, boolValue, channel, channelCode, channelId, channelName, countBytesInsteadOfCharacters, createdAt, createdBy, createdById, createdByName, data, dateValue, datetimeValue, deleted, filterCreateImportJob, filterUpdateImportJob, floatValue, floatValue1, icons, id, intValue, intValue1, isInheritAssignedUser, isInheritOwnerUser, isInheritTeams, isInherited, isPavRelationInherited, isPavValueInherited, isRequired, isValueReadOnly, isVariantSpecificAttribute, language, mainLanguageId, max, maxLength, min, modifiedAt, modifiedBy, modifiedById, modifiedByName, name, ownerUser, ownerUserId, ownerUserName, product, productId, productName, product_amount, product_assignedUser, product_assignedUserId, product_assignedUserName, product_brand, product_brandId, product_brandName, product_catalog, product_catalogId, product_catalogName, product_createdAt, product_createdBy, product_createdById, product_createdByName, product_data, product_ean, product_filterCreateImportJob, product_filterUpdateImportJob, product_hasChildren, product_hierarchyRoute, product_hierarchySortOrder, product_inheritedFields, product_isActive, product_isInheritAssignedUser, product_isInheritOwnerUser, product_isInheritTeams, product_isRoot, product_longDescription, product_longDescriptionDeDe, product_mainImageId, product_mainImageName, product_mainImagePathsData, product_modifiedAt, product_modifiedAtExpanded, product_modifiedBy, product_modifiedById, product_modifiedByName, product_mpn, product_name, product_nameDeDe, product_ownerUser, product_ownerUserId, product_ownerUserName, product_packaging, product_packagingId, product_packagingName, product_price, product_priceCurrency, product_productSerie, product_productSerieId, product_productSerieName, product_productStatus, product_scope, product_sku, product_sortOrder, product_sorting, product_tag, product_taskStatus, product_tax, product_taxId, product_taxName, product_uvp, prohibitedEmptyValue, scope, sortOrder, teams, teamsIds, teamsNames, textValue, useDisabledTextareaInViewMode, value, valueAllUnits, valueCurrency, valueFrom, valueId, valueName, valueNames, valueOptionData, valueOptionsData, valuePathsData, valueTo, valueUnit, valueUnitId, varcharValue
        :type select: str
        :param where: There are a lot of filter types supported. You can learn all of them if you trace what's requested by Atro UI in the network tab in your browser console (press F12 key to open the console).
        :type where: List[object]
        :param offset:
        :type offset: int
        :param max_size:
        :type max_size: int
        :param sort_by:
        :type sort_by: str
        :param asc:
        :type asc: bool
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: GetListOfProductAttributeValueItems200Response
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the get_list_of_product_attribute_value_items_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.get_list_of_product_attribute_value_items_with_http_info(language, select, where, offset, max_size, sort_by, asc, **kwargs)  # noqa: E501

    @validate_arguments
    def get_list_of_product_attribute_value_items_with_http_info(self, language : Annotated[Optional[StrictStr], Field(description="Set this parameter for data to be returned for a specified language")] = None, select : Annotated[Optional[StrictStr], Field(description="Available fields: amountOfDigitsAfterComma, assignedUser, assignedUserId, assignedUserName, attribute, attributeAssetType, attributeCode, attributeEntityType, attributeExtensibleEnumId, attributeGroup, attributeGroupId, attributeGroupName, attributeId, attributeIsMultilang, attributeMeasureId, attributeName, attributeTooltip, attributeType, attribute_amountOfDigitsAfterComma, attribute_assetType, attribute_assignedUser, attribute_assignedUserId, attribute_assignedUserName, attribute_attributeGroup, attribute_attributeGroupId, attribute_attributeGroupName, attribute_attributeTab, attribute_attributeTabId, attribute_attributeTabName, attribute_code, attribute_countBytesInsteadOfCharacters, attribute_createdAt, attribute_createdBy, attribute_createdById, attribute_createdByName, attribute_data, attribute_defaultChannel, attribute_defaultChannelId, attribute_defaultChannelName, attribute_defaultScope, attribute_defaultUnit, attribute_description, attribute_descriptionDeDe, attribute_extensibleEnum, attribute_extensibleEnumId, attribute_extensibleEnumName, attribute_filterCreateImportJob, attribute_filterUpdateImportJob, attribute_hasChildren, attribute_hierarchyRoute, attribute_hierarchySortOrder, attribute_inheritedFields, attribute_isMultilang, attribute_isRequired, attribute_isRoot, attribute_max, attribute_maxLength, attribute_measure, attribute_measureId, attribute_measureName, attribute_min, attribute_modifiedAt, attribute_modifiedBy, attribute_modifiedById, attribute_modifiedByName, attribute_name, attribute_nameDeDe, attribute_ownerUser, attribute_ownerUserId, attribute_ownerUserName, attribute_pattern, attribute_prohibitedEmptyValue, attribute_sortOrder, attribute_sortOrderInAttributeGroup, attribute_sortOrderInProduct, attribute_tooltip, attribute_tooltipDeDe, attribute_type, attribute_unique, attribute_useDisabledTextareaInViewMode, attribute_virtualProductField, boolValue, channel, channelCode, channelId, channelName, countBytesInsteadOfCharacters, createdAt, createdBy, createdById, createdByName, data, dateValue, datetimeValue, deleted, filterCreateImportJob, filterUpdateImportJob, floatValue, floatValue1, icons, id, intValue, intValue1, isInheritAssignedUser, isInheritOwnerUser, isInheritTeams, isInherited, isPavRelationInherited, isPavValueInherited, isRequired, isValueReadOnly, isVariantSpecificAttribute, language, mainLanguageId, max, maxLength, min, modifiedAt, modifiedBy, modifiedById, modifiedByName, name, ownerUser, ownerUserId, ownerUserName, product, productId, productName, product_amount, product_assignedUser, product_assignedUserId, product_assignedUserName, product_brand, product_brandId, product_brandName, product_catalog, product_catalogId, product_catalogName, product_createdAt, product_createdBy, product_createdById, product_createdByName, product_data, product_ean, product_filterCreateImportJob, product_filterUpdateImportJob, product_hasChildren, product_hierarchyRoute, product_hierarchySortOrder, product_inheritedFields, product_isActive, product_isInheritAssignedUser, product_isInheritOwnerUser, product_isInheritTeams, product_isRoot, product_longDescription, product_longDescriptionDeDe, product_mainImageId, product_mainImageName, product_mainImagePathsData, product_modifiedAt, product_modifiedAtExpanded, product_modifiedBy, product_modifiedById, product_modifiedByName, product_mpn, product_name, product_nameDeDe, product_ownerUser, product_ownerUserId, product_ownerUserName, product_packaging, product_packagingId, product_packagingName, product_price, product_priceCurrency, product_productSerie, product_productSerieId, product_productSerieName, product_productStatus, product_scope, product_sku, product_sortOrder, product_sorting, product_tag, product_taskStatus, product_tax, product_taxId, product_taxName, product_uvp, prohibitedEmptyValue, scope, sortOrder, teams, teamsIds, teamsNames, textValue, useDisabledTextareaInViewMode, value, valueAllUnits, valueCurrency, valueFrom, valueId, valueName, valueNames, valueOptionData, valueOptionsData, valuePathsData, valueTo, valueUnit, valueUnitId, varcharValue")] = None, where : Annotated[Optional[conlist(Dict[str, Any])], Field(description="There are a lot of filter types supported. You can learn all of them if you trace what's requested by Atro UI in the network tab in your browser console (press F12 key to open the console).")] = None, offset : Optional[StrictInt] = None, max_size : Optional[StrictInt] = None, sort_by : Optional[StrictStr] = None, asc : Optional[StrictBool] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """Returns a collection of ProductAttributeValue records  # noqa: E501

        Returns a collection of ProductAttributeValue records  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_list_of_product_attribute_value_items_with_http_info(language, select, where, offset, max_size, sort_by, asc, async_req=True)
        >>> result = thread.get()

        :param language: Set this parameter for data to be returned for a specified language
        :type language: str
        :param select: Available fields: amountOfDigitsAfterComma, assignedUser, assignedUserId, assignedUserName, attribute, attributeAssetType, attributeCode, attributeEntityType, attributeExtensibleEnumId, attributeGroup, attributeGroupId, attributeGroupName, attributeId, attributeIsMultilang, attributeMeasureId, attributeName, attributeTooltip, attributeType, attribute_amountOfDigitsAfterComma, attribute_assetType, attribute_assignedUser, attribute_assignedUserId, attribute_assignedUserName, attribute_attributeGroup, attribute_attributeGroupId, attribute_attributeGroupName, attribute_attributeTab, attribute_attributeTabId, attribute_attributeTabName, attribute_code, attribute_countBytesInsteadOfCharacters, attribute_createdAt, attribute_createdBy, attribute_createdById, attribute_createdByName, attribute_data, attribute_defaultChannel, attribute_defaultChannelId, attribute_defaultChannelName, attribute_defaultScope, attribute_defaultUnit, attribute_description, attribute_descriptionDeDe, attribute_extensibleEnum, attribute_extensibleEnumId, attribute_extensibleEnumName, attribute_filterCreateImportJob, attribute_filterUpdateImportJob, attribute_hasChildren, attribute_hierarchyRoute, attribute_hierarchySortOrder, attribute_inheritedFields, attribute_isMultilang, attribute_isRequired, attribute_isRoot, attribute_max, attribute_maxLength, attribute_measure, attribute_measureId, attribute_measureName, attribute_min, attribute_modifiedAt, attribute_modifiedBy, attribute_modifiedById, attribute_modifiedByName, attribute_name, attribute_nameDeDe, attribute_ownerUser, attribute_ownerUserId, attribute_ownerUserName, attribute_pattern, attribute_prohibitedEmptyValue, attribute_sortOrder, attribute_sortOrderInAttributeGroup, attribute_sortOrderInProduct, attribute_tooltip, attribute_tooltipDeDe, attribute_type, attribute_unique, attribute_useDisabledTextareaInViewMode, attribute_virtualProductField, boolValue, channel, channelCode, channelId, channelName, countBytesInsteadOfCharacters, createdAt, createdBy, createdById, createdByName, data, dateValue, datetimeValue, deleted, filterCreateImportJob, filterUpdateImportJob, floatValue, floatValue1, icons, id, intValue, intValue1, isInheritAssignedUser, isInheritOwnerUser, isInheritTeams, isInherited, isPavRelationInherited, isPavValueInherited, isRequired, isValueReadOnly, isVariantSpecificAttribute, language, mainLanguageId, max, maxLength, min, modifiedAt, modifiedBy, modifiedById, modifiedByName, name, ownerUser, ownerUserId, ownerUserName, product, productId, productName, product_amount, product_assignedUser, product_assignedUserId, product_assignedUserName, product_brand, product_brandId, product_brandName, product_catalog, product_catalogId, product_catalogName, product_createdAt, product_createdBy, product_createdById, product_createdByName, product_data, product_ean, product_filterCreateImportJob, product_filterUpdateImportJob, product_hasChildren, product_hierarchyRoute, product_hierarchySortOrder, product_inheritedFields, product_isActive, product_isInheritAssignedUser, product_isInheritOwnerUser, product_isInheritTeams, product_isRoot, product_longDescription, product_longDescriptionDeDe, product_mainImageId, product_mainImageName, product_mainImagePathsData, product_modifiedAt, product_modifiedAtExpanded, product_modifiedBy, product_modifiedById, product_modifiedByName, product_mpn, product_name, product_nameDeDe, product_ownerUser, product_ownerUserId, product_ownerUserName, product_packaging, product_packagingId, product_packagingName, product_price, product_priceCurrency, product_productSerie, product_productSerieId, product_productSerieName, product_productStatus, product_scope, product_sku, product_sortOrder, product_sorting, product_tag, product_taskStatus, product_tax, product_taxId, product_taxName, product_uvp, prohibitedEmptyValue, scope, sortOrder, teams, teamsIds, teamsNames, textValue, useDisabledTextareaInViewMode, value, valueAllUnits, valueCurrency, valueFrom, valueId, valueName, valueNames, valueOptionData, valueOptionsData, valuePathsData, valueTo, valueUnit, valueUnitId, varcharValue
        :type select: str
        :param where: There are a lot of filter types supported. You can learn all of them if you trace what's requested by Atro UI in the network tab in your browser console (press F12 key to open the console).
        :type where: List[object]
        :param offset:
        :type offset: int
        :param max_size:
        :type max_size: int
        :param sort_by:
        :type sort_by: str
        :param asc:
        :type asc: bool
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(GetListOfProductAttributeValueItems200Response, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'language',
            'select',
            'where',
            'offset',
            'max_size',
            'sort_by',
            'asc'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_list_of_product_attribute_value_items" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('select') is not None:  # noqa: E501
            _query_params.append(('select', _params['select']))

        if _params.get('where') is not None:  # noqa: E501
            _query_params.append(('where', _params['where']))
            _collection_formats['where'] = 'csv'

        if _params.get('offset') is not None:  # noqa: E501
            _query_params.append(('offset', _params['offset']))

        if _params.get('max_size') is not None:  # noqa: E501
            _query_params.append(('maxSize', _params['max_size']))

        if _params.get('sort_by') is not None:  # noqa: E501
            _query_params.append(('sortBy', _params['sort_by']))

        if _params.get('asc') is not None:  # noqa: E501
            _query_params.append(('asc', _params['asc']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        if _params['language']:
            _header_params['language'] = _params['language']

        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['Authorization-Token']  # noqa: E501

        _response_types_map = {
            '200': "GetListOfProductAttributeValueItems200Response",
            '304': None,
            '400': None,
            '401': None,
            '403': None,
            '404': None,
            '500': None,
        }

        return self.api_client.call_api(
            '/ProductAttributeValue', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def get_product_attribute_value_item(self, id : StrictStr, language : Annotated[Optional[StrictStr], Field(description="Set this parameter for data to be returned for a specified language")] = None, **kwargs) -> ProductAttributeValue:  # noqa: E501
        """Returns a record of the ProductAttributeValue  # noqa: E501

        Returns a record of the ProductAttributeValue  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_product_attribute_value_item(id, language, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param language: Set this parameter for data to be returned for a specified language
        :type language: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: ProductAttributeValue
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the get_product_attribute_value_item_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.get_product_attribute_value_item_with_http_info(id, language, **kwargs)  # noqa: E501

    @validate_arguments
    def get_product_attribute_value_item_with_http_info(self, id : StrictStr, language : Annotated[Optional[StrictStr], Field(description="Set this parameter for data to be returned for a specified language")] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """Returns a record of the ProductAttributeValue  # noqa: E501

        Returns a record of the ProductAttributeValue  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_product_attribute_value_item_with_http_info(id, language, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param language: Set this parameter for data to be returned for a specified language
        :type language: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(ProductAttributeValue, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'id',
            'language'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_product_attribute_value_item" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['id']:
            _path_params['id'] = _params['id']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        if _params['language']:
            _header_params['language'] = _params['language']

        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['Authorization-Token']  # noqa: E501

        _response_types_map = {
            '200': "ProductAttributeValue",
            '304': None,
            '400': None,
            '401': None,
            '403': None,
            '404': None,
            '500': None,
        }

        return self.api_client.call_api(
            '/ProductAttributeValue/{id}', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def link_product_attribute_value(self, id : StrictStr, link : StrictStr, link_account_request : LinkAccountRequest, **kwargs) -> bool:  # noqa: E501
        """Link ProductAttributeValue to Entities  # noqa: E501

        Link ProductAttributeValue to Entities  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.link_product_attribute_value(id, link, link_account_request, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param link: (required)
        :type link: str
        :param link_account_request: (required)
        :type link_account_request: LinkAccountRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: bool
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the link_product_attribute_value_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.link_product_attribute_value_with_http_info(id, link, link_account_request, **kwargs)  # noqa: E501

    @validate_arguments
    def link_product_attribute_value_with_http_info(self, id : StrictStr, link : StrictStr, link_account_request : LinkAccountRequest, **kwargs) -> ApiResponse:  # noqa: E501
        """Link ProductAttributeValue to Entities  # noqa: E501

        Link ProductAttributeValue to Entities  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.link_product_attribute_value_with_http_info(id, link, link_account_request, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param link: (required)
        :type link: str
        :param link_account_request: (required)
        :type link_account_request: LinkAccountRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(bool, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'id',
            'link',
            'link_account_request'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method link_product_attribute_value" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['id']:
            _path_params['id'] = _params['id']

        if _params['link']:
            _path_params['link'] = _params['link']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['link_account_request'] is not None:
            _body_params = _params['link_account_request']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['Authorization-Token']  # noqa: E501

        _response_types_map = {
            '200': "bool",
            '304': None,
            '400': None,
            '401': None,
            '403': None,
            '404': None,
            '500': None,
        }

        return self.api_client.call_api(
            '/ProductAttributeValue/{id}/{link}', 'POST',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def mass_delete_product_attribute_value(self, link_account_request : LinkAccountRequest, **kwargs) -> bool:  # noqa: E501
        """Mass delete of ProductAttributeValue data  # noqa: E501

        Mass delete of ProductAttributeValue data  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.mass_delete_product_attribute_value(link_account_request, async_req=True)
        >>> result = thread.get()

        :param link_account_request: (required)
        :type link_account_request: LinkAccountRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: bool
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the mass_delete_product_attribute_value_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.mass_delete_product_attribute_value_with_http_info(link_account_request, **kwargs)  # noqa: E501

    @validate_arguments
    def mass_delete_product_attribute_value_with_http_info(self, link_account_request : LinkAccountRequest, **kwargs) -> ApiResponse:  # noqa: E501
        """Mass delete of ProductAttributeValue data  # noqa: E501

        Mass delete of ProductAttributeValue data  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.mass_delete_product_attribute_value_with_http_info(link_account_request, async_req=True)
        >>> result = thread.get()

        :param link_account_request: (required)
        :type link_account_request: LinkAccountRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(bool, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'link_account_request'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method mass_delete_product_attribute_value" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['link_account_request'] is not None:
            _body_params = _params['link_account_request']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['Authorization-Token']  # noqa: E501

        _response_types_map = {
            '200': "bool",
            '304': None,
            '400': None,
            '401': None,
            '403': None,
            '404': None,
            '500': None,
        }

        return self.api_client.call_api(
            '/ProductAttributeValue/action/massDelete', 'POST',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def mass_update_product_attribute_value(self, mass_update_account_request : MassUpdateAccountRequest, **kwargs) -> bool:  # noqa: E501
        """Mass update of ProductAttributeValue data  # noqa: E501

        Mass update of ProductAttributeValue data  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.mass_update_product_attribute_value(mass_update_account_request, async_req=True)
        >>> result = thread.get()

        :param mass_update_account_request: (required)
        :type mass_update_account_request: MassUpdateAccountRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: bool
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the mass_update_product_attribute_value_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.mass_update_product_attribute_value_with_http_info(mass_update_account_request, **kwargs)  # noqa: E501

    @validate_arguments
    def mass_update_product_attribute_value_with_http_info(self, mass_update_account_request : MassUpdateAccountRequest, **kwargs) -> ApiResponse:  # noqa: E501
        """Mass update of ProductAttributeValue data  # noqa: E501

        Mass update of ProductAttributeValue data  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.mass_update_product_attribute_value_with_http_info(mass_update_account_request, async_req=True)
        >>> result = thread.get()

        :param mass_update_account_request: (required)
        :type mass_update_account_request: MassUpdateAccountRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(bool, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'mass_update_account_request'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method mass_update_product_attribute_value" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['mass_update_account_request'] is not None:
            _body_params = _params['mass_update_account_request']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['Authorization-Token']  # noqa: E501

        _response_types_map = {
            '200': "bool",
            '304': None,
            '400': None,
            '401': None,
            '403': None,
            '404': None,
            '500': None,
        }

        return self.api_client.call_api(
            '/ProductAttributeValue/action/massUpdate', 'PUT',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def remove_relation_for_product_attribute_value(self, link : StrictStr, ids : conlist(StrictStr), foreign_ids : conlist(StrictStr), **kwargs) -> bool:  # noqa: E501
        """Remove relation for ProductAttributeValue  # noqa: E501

        Remove relation for ProductAttributeValue  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.remove_relation_for_product_attribute_value(link, ids, foreign_ids, async_req=True)
        >>> result = thread.get()

        :param link: (required)
        :type link: str
        :param ids: (required)
        :type ids: List[str]
        :param foreign_ids: (required)
        :type foreign_ids: List[str]
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: bool
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the remove_relation_for_product_attribute_value_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.remove_relation_for_product_attribute_value_with_http_info(link, ids, foreign_ids, **kwargs)  # noqa: E501

    @validate_arguments
    def remove_relation_for_product_attribute_value_with_http_info(self, link : StrictStr, ids : conlist(StrictStr), foreign_ids : conlist(StrictStr), **kwargs) -> ApiResponse:  # noqa: E501
        """Remove relation for ProductAttributeValue  # noqa: E501

        Remove relation for ProductAttributeValue  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.remove_relation_for_product_attribute_value_with_http_info(link, ids, foreign_ids, async_req=True)
        >>> result = thread.get()

        :param link: (required)
        :type link: str
        :param ids: (required)
        :type ids: List[str]
        :param foreign_ids: (required)
        :type foreign_ids: List[str]
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(bool, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'link',
            'ids',
            'foreign_ids'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method remove_relation_for_product_attribute_value" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['link']:
            _path_params['link'] = _params['link']


        # process the query parameters
        _query_params = []
        if _params.get('ids') is not None:  # noqa: E501
            _query_params.append(('ids', _params['ids']))
            _collection_formats['ids'] = 'csv'

        if _params.get('foreign_ids') is not None:  # noqa: E501
            _query_params.append(('foreignIds', _params['foreign_ids']))
            _collection_formats['foreignIds'] = 'csv'

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['Authorization-Token']  # noqa: E501

        _response_types_map = {
            '200': "bool",
            '304': None,
            '400': None,
            '401': None,
            '403': None,
            '404': None,
            '500': None,
        }

        return self.api_client.call_api(
            '/ProductAttributeValue/{link}/relation', 'DELETE',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def unfollow_product_attribute_value(self, id : StrictStr, **kwargs) -> bool:  # noqa: E501
        """Unfollow the ProductAttributeValue stream  # noqa: E501

        Unfollow the ProductAttributeValue stream  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.unfollow_product_attribute_value(id, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: bool
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the unfollow_product_attribute_value_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.unfollow_product_attribute_value_with_http_info(id, **kwargs)  # noqa: E501

    @validate_arguments
    def unfollow_product_attribute_value_with_http_info(self, id : StrictStr, **kwargs) -> ApiResponse:  # noqa: E501
        """Unfollow the ProductAttributeValue stream  # noqa: E501

        Unfollow the ProductAttributeValue stream  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.unfollow_product_attribute_value_with_http_info(id, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(bool, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'id'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method unfollow_product_attribute_value" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['id']:
            _path_params['id'] = _params['id']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['Authorization-Token']  # noqa: E501

        _response_types_map = {
            '200': "bool",
            '304': None,
            '400': None,
            '401': None,
            '403': None,
            '404': None,
            '500': None,
        }

        return self.api_client.call_api(
            '/ProductAttributeValue/{id}/subscription', 'DELETE',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def unlink_product_attribute_value(self, id : StrictStr, link : StrictStr, ids : conlist(StrictStr), **kwargs) -> bool:  # noqa: E501
        """Unlink ProductAttributeValue from Entities  # noqa: E501

        Unlink ProductAttributeValue from Entities  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.unlink_product_attribute_value(id, link, ids, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param link: (required)
        :type link: str
        :param ids: (required)
        :type ids: List[str]
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: bool
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the unlink_product_attribute_value_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.unlink_product_attribute_value_with_http_info(id, link, ids, **kwargs)  # noqa: E501

    @validate_arguments
    def unlink_product_attribute_value_with_http_info(self, id : StrictStr, link : StrictStr, ids : conlist(StrictStr), **kwargs) -> ApiResponse:  # noqa: E501
        """Unlink ProductAttributeValue from Entities  # noqa: E501

        Unlink ProductAttributeValue from Entities  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.unlink_product_attribute_value_with_http_info(id, link, ids, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param link: (required)
        :type link: str
        :param ids: (required)
        :type ids: List[str]
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(bool, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'id',
            'link',
            'ids'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method unlink_product_attribute_value" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['id']:
            _path_params['id'] = _params['id']

        if _params['link']:
            _path_params['link'] = _params['link']


        # process the query parameters
        _query_params = []
        if _params.get('ids') is not None:  # noqa: E501
            _query_params.append(('ids', _params['ids']))
            _collection_formats['ids'] = 'csv'

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['Authorization-Token']  # noqa: E501

        _response_types_map = {
            '200': "bool",
            '304': None,
            '400': None,
            '401': None,
            '403': None,
            '404': None,
            '500': None,
        }

        return self.api_client.call_api(
            '/ProductAttributeValue/{id}/{link}', 'DELETE',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def update_product_attribute_value_item(self, id : StrictStr, create_product_attribute_value_item_request : CreateProductAttributeValueItemRequest, **kwargs) -> ProductAttributeValue:  # noqa: E501
        """Update a record of the ProductAttributeValue  # noqa: E501

        Update a record of the ProductAttributeValue  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.update_product_attribute_value_item(id, create_product_attribute_value_item_request, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param create_product_attribute_value_item_request: (required)
        :type create_product_attribute_value_item_request: CreateProductAttributeValueItemRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: ProductAttributeValue
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the update_product_attribute_value_item_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.update_product_attribute_value_item_with_http_info(id, create_product_attribute_value_item_request, **kwargs)  # noqa: E501

    @validate_arguments
    def update_product_attribute_value_item_with_http_info(self, id : StrictStr, create_product_attribute_value_item_request : CreateProductAttributeValueItemRequest, **kwargs) -> ApiResponse:  # noqa: E501
        """Update a record of the ProductAttributeValue  # noqa: E501

        Update a record of the ProductAttributeValue  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.update_product_attribute_value_item_with_http_info(id, create_product_attribute_value_item_request, async_req=True)
        >>> result = thread.get()

        :param id: (required)
        :type id: str
        :param create_product_attribute_value_item_request: (required)
        :type create_product_attribute_value_item_request: CreateProductAttributeValueItemRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(ProductAttributeValue, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'id',
            'create_product_attribute_value_item_request'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_product_attribute_value_item" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['id']:
            _path_params['id'] = _params['id']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['create_product_attribute_value_item_request'] is not None:
            _body_params = _params['create_product_attribute_value_item_request']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['Authorization-Token']  # noqa: E501

        _response_types_map = {
            '200': "ProductAttributeValue",
            '304': None,
            '400': None,
            '401': None,
            '403': None,
            '404': None,
            '500': None,
        }

        return self.api_client.call_api(
            '/ProductAttributeValue/{id}', 'PUT',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))
