# coding: utf-8

"""
    AtroCore REST API documentation

    This is a REST API documentation for AtroCore data platform and its modules (AtroPIM, AtroDAM and others), which is based on [OpenAPI (Swagger) Specification](https://swagger.io/specification/). You can generate your client [here](https://openapi-generator.tech/docs/generators).<br><br><h3>Video tutorials:</h3><ul><li>[How to authorize?](https://youtu.be/GWfNRvCswXg)</li><li>[How to select specific fields?](https://youtu.be/i7o0aENuyuY)</li><li>[How to filter data records?](https://youtu.be/irgWkN4wlkM)</li></ul>

    The version of the OpenAPI document: 1.6.55
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr

class ActionHistoryRecord(BaseModel):
    """
    ActionHistoryRecord
    """
    id: Optional[StrictStr] = None
    deleted: Optional[StrictBool] = None
    number: Optional[StrictInt] = None
    target_id: Optional[StrictStr] = Field(None, alias="targetId")
    target_name: Optional[StrictStr] = Field(None, alias="targetName")
    data: Optional[Dict[str, Any]] = None
    action: Optional[StrictStr] = None
    created_at: Optional[StrictStr] = Field(None, alias="createdAt")
    user_id: Optional[StrictStr] = Field(None, alias="userId")
    user_name: Optional[StrictStr] = Field(None, alias="userName")
    ip_address: Optional[StrictStr] = Field(None, alias="ipAddress")
    auth_token_id: Optional[StrictStr] = Field(None, alias="authTokenId")
    auth_token_name: Optional[StrictStr] = Field(None, alias="authTokenName")
    auth_log_record_id: Optional[StrictStr] = Field(None, alias="authLogRecordId")
    auth_log_record_name: Optional[StrictStr] = Field(None, alias="authLogRecordName")
    __properties = ["id", "deleted", "number", "targetId", "targetName", "data", "action", "createdAt", "userId", "userName", "ipAddress", "authTokenId", "authTokenName", "authLogRecordId", "authLogRecordName"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ActionHistoryRecord:
        """Create an instance of ActionHistoryRecord from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ActionHistoryRecord:
        """Create an instance of ActionHistoryRecord from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ActionHistoryRecord.parse_obj(obj)

        _obj = ActionHistoryRecord.parse_obj({
            "id": obj.get("id"),
            "deleted": obj.get("deleted"),
            "number": obj.get("number"),
            "target_id": obj.get("targetId"),
            "target_name": obj.get("targetName"),
            "data": obj.get("data"),
            "action": obj.get("action"),
            "created_at": obj.get("createdAt"),
            "user_id": obj.get("userId"),
            "user_name": obj.get("userName"),
            "ip_address": obj.get("ipAddress"),
            "auth_token_id": obj.get("authTokenId"),
            "auth_token_name": obj.get("authTokenName"),
            "auth_log_record_id": obj.get("authLogRecordId"),
            "auth_log_record_name": obj.get("authLogRecordName")
        })
        return _obj


