# coding: utf-8

"""
    AtroCore REST API documentation

    This is a REST API documentation for AtroCore data platform and its modules (AtroPIM, AtroDAM and others), which is based on [OpenAPI (Swagger) Specification](https://swagger.io/specification/). You can generate your client [here](https://openapi-generator.tech/docs/generators).<br><br><h3>Video tutorials:</h3><ul><li>[How to authorize?](https://youtu.be/GWfNRvCswXg)</li><li>[How to select specific fields?](https://youtu.be/i7o0aENuyuY)</li><li>[How to filter data records?](https://youtu.be/irgWkN4wlkM)</li></ul>

    The version of the OpenAPI document: 1.6.55
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist

class Asset(BaseModel):
    """
    Asset
    """
    id: Optional[StrictStr] = None
    deleted: Optional[StrictBool] = None
    preview: Optional[StrictStr] = None
    icon: Optional[StrictStr] = None
    url: Optional[StrictStr] = None
    after_save_message: Optional[StrictStr] = Field(None, alias="afterSaveMessage")
    height: Optional[StrictInt] = None
    width: Optional[StrictInt] = None
    color_space: Optional[StrictStr] = Field(None, alias="colorSpace")
    color_depth: Optional[StrictStr] = Field(None, alias="colorDepth")
    orientation: Optional[StrictStr] = None
    is_active: Optional[StrictBool] = Field(None, alias="isActive")
    tags: Optional[conlist(StrictStr)] = None
    library_id: Optional[StrictStr] = Field(None, alias="libraryId")
    library_name: Optional[StrictStr] = Field(None, alias="libraryName")
    asset_categories_ids: Optional[conlist(StrictStr)] = Field(None, alias="assetCategoriesIds")
    asset_categories_names: Optional[Dict[str, Any]] = Field(None, alias="assetCategoriesNames")
    name: Optional[StrictStr] = None
    description: Optional[StrictStr] = None
    description_de_de: Optional[StrictStr] = Field(None, alias="descriptionDeDe")
    created_at: Optional[StrictStr] = Field(None, alias="createdAt")
    modified_at: Optional[StrictStr] = Field(None, alias="modifiedAt")
    created_by_id: Optional[StrictStr] = Field(None, alias="createdById")
    created_by_name: Optional[StrictStr] = Field(None, alias="createdByName")
    modified_by_id: Optional[StrictStr] = Field(None, alias="modifiedById")
    modified_by_name: Optional[StrictStr] = Field(None, alias="modifiedByName")
    private: Optional[StrictBool] = None
    file_id: Optional[StrictStr] = Field(None, alias="fileId")
    file_name: Optional[StrictStr] = Field(None, alias="fileName")
    files: StrictStr = Field(...)
    size: Optional[StrictStr] = None
    parents_ids: Optional[conlist(StrictStr)] = Field(None, alias="parentsIds")
    parents_names: Optional[Dict[str, Any]] = Field(None, alias="parentsNames")
    sort_order: Optional[StrictInt] = Field(None, alias="sortOrder")
    __properties = ["id", "deleted", "preview", "icon", "url", "afterSaveMessage", "height", "width", "colorSpace", "colorDepth", "orientation", "isActive", "tags", "libraryId", "libraryName", "assetCategoriesIds", "assetCategoriesNames", "name", "description", "descriptionDeDe", "createdAt", "modifiedAt", "createdById", "createdByName", "modifiedById", "modifiedByName", "private", "fileId", "fileName", "files", "size", "parentsIds", "parentsNames", "sortOrder"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Asset:
        """Create an instance of Asset from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Asset:
        """Create an instance of Asset from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Asset.parse_obj(obj)

        _obj = Asset.parse_obj({
            "id": obj.get("id"),
            "deleted": obj.get("deleted"),
            "preview": obj.get("preview"),
            "icon": obj.get("icon"),
            "url": obj.get("url"),
            "after_save_message": obj.get("afterSaveMessage"),
            "height": obj.get("height"),
            "width": obj.get("width"),
            "color_space": obj.get("colorSpace"),
            "color_depth": obj.get("colorDepth"),
            "orientation": obj.get("orientation"),
            "is_active": obj.get("isActive"),
            "tags": obj.get("tags"),
            "library_id": obj.get("libraryId"),
            "library_name": obj.get("libraryName"),
            "asset_categories_ids": obj.get("assetCategoriesIds"),
            "asset_categories_names": obj.get("assetCategoriesNames"),
            "name": obj.get("name"),
            "description": obj.get("description"),
            "description_de_de": obj.get("descriptionDeDe"),
            "created_at": obj.get("createdAt"),
            "modified_at": obj.get("modifiedAt"),
            "created_by_id": obj.get("createdById"),
            "created_by_name": obj.get("createdByName"),
            "modified_by_id": obj.get("modifiedById"),
            "modified_by_name": obj.get("modifiedByName"),
            "private": obj.get("private"),
            "file_id": obj.get("fileId"),
            "file_name": obj.get("fileName"),
            "files": obj.get("files"),
            "size": obj.get("size"),
            "parents_ids": obj.get("parentsIds"),
            "parents_names": obj.get("parentsNames"),
            "sort_order": obj.get("sortOrder")
        })
        return _obj


