# coding: utf-8

"""
    AtroCore REST API documentation

    This is a REST API documentation for AtroCore data platform and its modules (AtroPIM, AtroDAM and others), which is based on [OpenAPI (Swagger) Specification](https://swagger.io/specification/). You can generate your client [here](https://openapi-generator.tech/docs/generators).<br><br><h3>Video tutorials:</h3><ul><li>[How to authorize?](https://youtu.be/GWfNRvCswXg)</li><li>[How to select specific fields?](https://youtu.be/i7o0aENuyuY)</li><li>[How to filter data records?](https://youtu.be/irgWkN4wlkM)</li></ul>

    The version of the OpenAPI document: 1.6.55
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr

class AssociatedProduct(BaseModel):
    """
    AssociatedProduct
    """
    id: Optional[StrictStr] = None
    deleted: Optional[StrictBool] = None
    association_id: Optional[StrictStr] = Field(None, alias="associationId")
    association_name: Optional[StrictStr] = Field(None, alias="associationName")
    main_product_id: Optional[StrictStr] = Field(None, alias="mainProductId")
    main_product_name: Optional[StrictStr] = Field(None, alias="mainProductName")
    related_product_id: Optional[StrictStr] = Field(None, alias="relatedProductId")
    related_product_name: Optional[StrictStr] = Field(None, alias="relatedProductName")
    backward_association_id: Optional[StrictStr] = Field(None, alias="backwardAssociationId")
    backward_association_name: Optional[StrictStr] = Field(None, alias="backwardAssociationName")
    created_at: Optional[StrictStr] = Field(None, alias="createdAt")
    modified_at: Optional[StrictStr] = Field(None, alias="modifiedAt")
    created_by_id: Optional[StrictStr] = Field(None, alias="createdById")
    created_by_name: Optional[StrictStr] = Field(None, alias="createdByName")
    modified_by_id: Optional[StrictStr] = Field(None, alias="modifiedById")
    modified_by_name: Optional[StrictStr] = Field(None, alias="modifiedByName")
    sorting: Optional[StrictInt] = None
    main_product_image_id: Optional[StrictStr] = Field(None, alias="mainProductImageId")
    main_product_image_name: Optional[StrictStr] = Field(None, alias="mainProductImageName")
    related_product_image_id: Optional[StrictStr] = Field(None, alias="relatedProductImageId")
    related_product_image_name: Optional[StrictStr] = Field(None, alias="relatedProductImageName")
    __properties = ["id", "deleted", "associationId", "associationName", "mainProductId", "mainProductName", "relatedProductId", "relatedProductName", "backwardAssociationId", "backwardAssociationName", "createdAt", "modifiedAt", "createdById", "createdByName", "modifiedById", "modifiedByName", "sorting", "mainProductImageId", "mainProductImageName", "relatedProductImageId", "relatedProductImageName"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AssociatedProduct:
        """Create an instance of AssociatedProduct from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AssociatedProduct:
        """Create an instance of AssociatedProduct from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AssociatedProduct.parse_obj(obj)

        _obj = AssociatedProduct.parse_obj({
            "id": obj.get("id"),
            "deleted": obj.get("deleted"),
            "association_id": obj.get("associationId"),
            "association_name": obj.get("associationName"),
            "main_product_id": obj.get("mainProductId"),
            "main_product_name": obj.get("mainProductName"),
            "related_product_id": obj.get("relatedProductId"),
            "related_product_name": obj.get("relatedProductName"),
            "backward_association_id": obj.get("backwardAssociationId"),
            "backward_association_name": obj.get("backwardAssociationName"),
            "created_at": obj.get("createdAt"),
            "modified_at": obj.get("modifiedAt"),
            "created_by_id": obj.get("createdById"),
            "created_by_name": obj.get("createdByName"),
            "modified_by_id": obj.get("modifiedById"),
            "modified_by_name": obj.get("modifiedByName"),
            "sorting": obj.get("sorting"),
            "main_product_image_id": obj.get("mainProductImageId"),
            "main_product_image_name": obj.get("mainProductImageName"),
            "related_product_image_id": obj.get("relatedProductImageId"),
            "related_product_image_name": obj.get("relatedProductImageName")
        })
        return _obj


