# coding: utf-8

"""
    AtroCore REST API documentation

    This is a REST API documentation for AtroCore data platform and its modules (AtroPIM, AtroDAM and others), which is based on [OpenAPI (Swagger) Specification](https://swagger.io/specification/). You can generate your client [here](https://openapi-generator.tech/docs/generators).<br><br><h3>Video tutorials:</h3><ul><li>[How to authorize?](https://youtu.be/GWfNRvCswXg)</li><li>[How to select specific fields?](https://youtu.be/i7o0aENuyuY)</li><li>[How to filter data records?](https://youtu.be/irgWkN4wlkM)</li></ul>

    The version of the OpenAPI document: 1.6.55
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr

class AuthToken(BaseModel):
    """
    AuthToken
    """
    id: Optional[StrictStr] = None
    deleted: Optional[StrictBool] = None
    token: Optional[StrictStr] = None
    hash: Optional[StrictStr] = None
    user_id: Optional[StrictStr] = Field(None, alias="userId")
    user_name: Optional[StrictStr] = Field(None, alias="userName")
    portal_id: Optional[StrictStr] = Field(None, alias="portalId")
    portal_name: Optional[StrictStr] = Field(None, alias="portalName")
    ip_address: Optional[StrictStr] = Field(None, alias="ipAddress")
    is_active: Optional[StrictBool] = Field(None, alias="isActive")
    last_access: Optional[StrictStr] = Field(None, alias="lastAccess")
    created_at: Optional[StrictStr] = Field(None, alias="createdAt")
    modified_at: Optional[StrictStr] = Field(None, alias="modifiedAt")
    lifetime: Optional[StrictInt] = None
    idle_time: Optional[StrictInt] = Field(None, alias="idleTime")
    __properties = ["id", "deleted", "token", "hash", "userId", "userName", "portalId", "portalName", "ipAddress", "isActive", "lastAccess", "createdAt", "modifiedAt", "lifetime", "idleTime"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AuthToken:
        """Create an instance of AuthToken from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AuthToken:
        """Create an instance of AuthToken from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AuthToken.parse_obj(obj)

        _obj = AuthToken.parse_obj({
            "id": obj.get("id"),
            "deleted": obj.get("deleted"),
            "token": obj.get("token"),
            "hash": obj.get("hash"),
            "user_id": obj.get("userId"),
            "user_name": obj.get("userName"),
            "portal_id": obj.get("portalId"),
            "portal_name": obj.get("portalName"),
            "ip_address": obj.get("ipAddress"),
            "is_active": obj.get("isActive"),
            "last_access": obj.get("lastAccess"),
            "created_at": obj.get("createdAt"),
            "modified_at": obj.get("modifiedAt"),
            "lifetime": obj.get("lifetime"),
            "idle_time": obj.get("idleTime")
        })
        return _obj


