# coding: utf-8

"""
    AtroCore REST API documentation

    This is a REST API documentation for AtroCore data platform and its modules (AtroPIM, AtroDAM and others), which is based on [OpenAPI (Swagger) Specification](https://swagger.io/specification/). You can generate your client [here](https://openapi-generator.tech/docs/generators).<br><br><h3>Video tutorials:</h3><ul><li>[How to authorize?](https://youtu.be/GWfNRvCswXg)</li><li>[How to select specific fields?](https://youtu.be/i7o0aENuyuY)</li><li>[How to filter data records?](https://youtu.be/irgWkN4wlkM)</li></ul>

    The version of the OpenAPI document: 1.6.55
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist

class CategoryAsset(BaseModel):
    """
    CategoryAsset
    """
    id: Optional[StrictStr] = None
    deleted: Optional[StrictBool] = None
    category_id: Optional[StrictStr] = Field(None, alias="categoryId")
    category_name: Optional[StrictStr] = Field(None, alias="categoryName")
    asset_id: Optional[StrictStr] = Field(None, alias="assetId")
    asset_name: Optional[StrictStr] = Field(None, alias="assetName")
    is_main_image: Optional[StrictBool] = Field(None, alias="isMainImage")
    sorting: Optional[StrictInt] = None
    tags: Optional[conlist(StrictStr)] = None
    created_at: Optional[StrictStr] = Field(None, alias="createdAt")
    modified_at: Optional[StrictStr] = Field(None, alias="modifiedAt")
    created_by_id: Optional[StrictStr] = Field(None, alias="createdById")
    created_by_name: Optional[StrictStr] = Field(None, alias="createdByName")
    modified_by_id: Optional[StrictStr] = Field(None, alias="modifiedById")
    modified_by_name: Optional[StrictStr] = Field(None, alias="modifiedByName")
    preview: Optional[StrictStr] = None
    __properties = ["id", "deleted", "categoryId", "categoryName", "assetId", "assetName", "isMainImage", "sorting", "tags", "createdAt", "modifiedAt", "createdById", "createdByName", "modifiedById", "modifiedByName", "preview"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CategoryAsset:
        """Create an instance of CategoryAsset from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CategoryAsset:
        """Create an instance of CategoryAsset from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CategoryAsset.parse_obj(obj)

        _obj = CategoryAsset.parse_obj({
            "id": obj.get("id"),
            "deleted": obj.get("deleted"),
            "category_id": obj.get("categoryId"),
            "category_name": obj.get("categoryName"),
            "asset_id": obj.get("assetId"),
            "asset_name": obj.get("assetName"),
            "is_main_image": obj.get("isMainImage"),
            "sorting": obj.get("sorting"),
            "tags": obj.get("tags"),
            "created_at": obj.get("createdAt"),
            "modified_at": obj.get("modifiedAt"),
            "created_by_id": obj.get("createdById"),
            "created_by_name": obj.get("createdByName"),
            "modified_by_id": obj.get("modifiedById"),
            "modified_by_name": obj.get("modifiedByName"),
            "preview": obj.get("preview")
        })
        return _obj


