# coding: utf-8

"""
    AtroCore REST API documentation

    This is a REST API documentation for AtroCore data platform and its modules (AtroPIM, AtroDAM and others), which is based on [OpenAPI (Swagger) Specification](https://swagger.io/specification/). You can generate your client [here](https://openapi-generator.tech/docs/generators).<br><br><h3>Video tutorials:</h3><ul><li>[How to authorize?](https://youtu.be/GWfNRvCswXg)</li><li>[How to select specific fields?](https://youtu.be/i7o0aENuyuY)</li><li>[How to filter data records?](https://youtu.be/irgWkN4wlkM)</li></ul>

    The version of the OpenAPI document: 1.6.55
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, conlist

class ClassificationAttribute(BaseModel):
    """
    ClassificationAttribute
    """
    id: Optional[StrictStr] = None
    deleted: Optional[StrictBool] = None
    classification_id: Optional[StrictStr] = Field(None, alias="classificationId")
    classification_name: Optional[StrictStr] = Field(None, alias="classificationName")
    attribute_id: Optional[StrictStr] = Field(None, alias="attributeId")
    attribute_name: Optional[StrictStr] = Field(None, alias="attributeName")
    language: Optional[StrictStr] = None
    languages: Optional[StrictStr] = None
    is_required: Optional[StrictBool] = Field(None, alias="isRequired")
    scope: StrictStr = Field(...)
    channel_id: Optional[StrictStr] = Field(None, alias="channelId")
    channel_name: Optional[StrictStr] = Field(None, alias="channelName")
    value: Optional[StrictStr] = None
    created_at: Optional[StrictStr] = Field(None, alias="createdAt")
    modified_at: Optional[StrictStr] = Field(None, alias="modifiedAt")
    created_by_id: Optional[StrictStr] = Field(None, alias="createdById")
    created_by_name: Optional[StrictStr] = Field(None, alias="createdByName")
    modified_by_id: Optional[StrictStr] = Field(None, alias="modifiedById")
    modified_by_name: Optional[StrictStr] = Field(None, alias="modifiedByName")
    owner_user_id: Optional[StrictStr] = Field(None, alias="ownerUserId")
    owner_user_name: Optional[StrictStr] = Field(None, alias="ownerUserName")
    assigned_user_id: Optional[StrictStr] = Field(None, alias="assignedUserId")
    assigned_user_name: Optional[StrictStr] = Field(None, alias="assignedUserName")
    teams_ids: Optional[conlist(StrictStr)] = Field(None, alias="teamsIds")
    teams_names: Optional[Dict[str, Any]] = Field(None, alias="teamsNames")
    __properties = ["id", "deleted", "classificationId", "classificationName", "attributeId", "attributeName", "language", "languages", "isRequired", "scope", "channelId", "channelName", "value", "createdAt", "modifiedAt", "createdById", "createdByName", "modifiedById", "modifiedByName", "ownerUserId", "ownerUserName", "assignedUserId", "assignedUserName", "teamsIds", "teamsNames"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ClassificationAttribute:
        """Create an instance of ClassificationAttribute from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ClassificationAttribute:
        """Create an instance of ClassificationAttribute from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ClassificationAttribute.parse_obj(obj)

        _obj = ClassificationAttribute.parse_obj({
            "id": obj.get("id"),
            "deleted": obj.get("deleted"),
            "classification_id": obj.get("classificationId"),
            "classification_name": obj.get("classificationName"),
            "attribute_id": obj.get("attributeId"),
            "attribute_name": obj.get("attributeName"),
            "language": obj.get("language"),
            "languages": obj.get("languages"),
            "is_required": obj.get("isRequired"),
            "scope": obj.get("scope"),
            "channel_id": obj.get("channelId"),
            "channel_name": obj.get("channelName"),
            "value": obj.get("value"),
            "created_at": obj.get("createdAt"),
            "modified_at": obj.get("modifiedAt"),
            "created_by_id": obj.get("createdById"),
            "created_by_name": obj.get("createdByName"),
            "modified_by_id": obj.get("modifiedById"),
            "modified_by_name": obj.get("modifiedByName"),
            "owner_user_id": obj.get("ownerUserId"),
            "owner_user_name": obj.get("ownerUserName"),
            "assigned_user_id": obj.get("assignedUserId"),
            "assigned_user_name": obj.get("assignedUserName"),
            "teams_ids": obj.get("teamsIds"),
            "teams_names": obj.get("teamsNames")
        })
        return _obj


