# coding: utf-8

"""
    AtroCore REST API documentation

    This is a REST API documentation for AtroCore data platform and its modules (AtroPIM, AtroDAM and others), which is based on [OpenAPI (Swagger) Specification](https://swagger.io/specification/). You can generate your client [here](https://openapi-generator.tech/docs/generators).<br><br><h3>Video tutorials:</h3><ul><li>[How to authorize?](https://youtu.be/GWfNRvCswXg)</li><li>[How to select specific fields?](https://youtu.be/i7o0aENuyuY)</li><li>[How to filter data records?](https://youtu.be/irgWkN4wlkM)</li></ul>

    The version of the OpenAPI document: 1.6.55
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist

class CreateAccountItemRequest(BaseModel):
    """
    CreateAccountItemRequest
    """
    name: StrictStr = Field(...)
    description: Optional[StrictStr] = None
    email_address: Optional[StrictStr] = Field(None, alias="emailAddress")
    phone_number: Optional[StrictStr] = Field(None, alias="phoneNumber")
    modified_by_id: Optional[StrictStr] = Field(None, alias="modifiedById")
    assigned_user_id: Optional[StrictStr] = Field(None, alias="assignedUserId")
    teams_ids: Optional[conlist(StrictStr)] = Field(None, alias="teamsIds")
    channel_id: Optional[StrictStr] = Field(None, alias="channelId")
    assigned_import_feeds_ids: Optional[conlist(StrictStr)] = Field(None, alias="assignedImportFeedsIds")
    assigned_export_feeds_ids: Optional[conlist(StrictStr)] = Field(None, alias="assignedExportFeedsIds")
    __properties = ["name", "description", "emailAddress", "phoneNumber", "modifiedById", "assignedUserId", "teamsIds", "channelId", "assignedImportFeedsIds", "assignedExportFeedsIds"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateAccountItemRequest:
        """Create an instance of CreateAccountItemRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateAccountItemRequest:
        """Create an instance of CreateAccountItemRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateAccountItemRequest.parse_obj(obj)

        _obj = CreateAccountItemRequest.parse_obj({
            "name": obj.get("name"),
            "description": obj.get("description"),
            "email_address": obj.get("emailAddress"),
            "phone_number": obj.get("phoneNumber"),
            "modified_by_id": obj.get("modifiedById"),
            "assigned_user_id": obj.get("assignedUserId"),
            "teams_ids": obj.get("teamsIds"),
            "channel_id": obj.get("channelId"),
            "assigned_import_feeds_ids": obj.get("assignedImportFeedsIds"),
            "assigned_export_feeds_ids": obj.get("assignedExportFeedsIds")
        })
        return _obj


