# coding: utf-8

"""
    AtroCore REST API documentation

    This is a REST API documentation for AtroCore data platform and its modules (AtroPIM, AtroDAM and others), which is based on [OpenAPI (Swagger) Specification](https://swagger.io/specification/). You can generate your client [here](https://openapi-generator.tech/docs/generators).<br><br><h3>Video tutorials:</h3><ul><li>[How to authorize?](https://youtu.be/GWfNRvCswXg)</li><li>[How to select specific fields?](https://youtu.be/i7o0aENuyuY)</li><li>[How to filter data records?](https://youtu.be/irgWkN4wlkM)</li></ul>

    The version of the OpenAPI document: 1.6.55
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr

class CreateAttachmentItemRequest(BaseModel):
    """
    CreateAttachmentItemRequest
    """
    name: StrictStr = Field(...)
    url: Optional[StrictStr] = None
    type: Optional[StrictStr] = None
    private: Optional[StrictBool] = None
    size: Optional[StrictStr] = None
    field: Optional[StrictStr] = None
    contents: Optional[StrictStr] = None
    role: Optional[StrictStr] = None
    storage: Optional[StrictStr] = None
    storage_file_path: Optional[StrictStr] = Field(None, alias="storageFilePath")
    storage_thumb_path: Optional[StrictStr] = Field(None, alias="storageThumbPath")
    var_global: Optional[StrictBool] = Field(None, alias="global")
    md5: Optional[StrictStr] = None
    paths_data: Optional[Dict[str, Any]] = Field(None, alias="pathsData")
    __properties = ["name", "url", "type", "private", "size", "field", "contents", "role", "storage", "storageFilePath", "storageThumbPath", "global", "md5", "pathsData"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateAttachmentItemRequest:
        """Create an instance of CreateAttachmentItemRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateAttachmentItemRequest:
        """Create an instance of CreateAttachmentItemRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateAttachmentItemRequest.parse_obj(obj)

        _obj = CreateAttachmentItemRequest.parse_obj({
            "name": obj.get("name"),
            "url": obj.get("url"),
            "type": obj.get("type"),
            "private": obj.get("private"),
            "size": obj.get("size"),
            "field": obj.get("field"),
            "contents": obj.get("contents"),
            "role": obj.get("role"),
            "storage": obj.get("storage"),
            "storage_file_path": obj.get("storageFilePath"),
            "storage_thumb_path": obj.get("storageThumbPath"),
            "var_global": obj.get("global"),
            "md5": obj.get("md5"),
            "paths_data": obj.get("pathsData")
        })
        return _obj


