# coding: utf-8

"""
    AtroCore REST API documentation

    This is a REST API documentation for AtroCore data platform and its modules (AtroPIM, AtroDAM and others), which is based on [OpenAPI (Swagger) Specification](https://swagger.io/specification/). You can generate your client [here](https://openapi-generator.tech/docs/generators).<br><br><h3>Video tutorials:</h3><ul><li>[How to authorize?](https://youtu.be/GWfNRvCswXg)</li><li>[How to select specific fields?](https://youtu.be/i7o0aENuyuY)</li><li>[How to filter data records?](https://youtu.be/irgWkN4wlkM)</li></ul>

    The version of the OpenAPI document: 1.6.55
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr

class CreateImportJobLogItemRequest(BaseModel):
    """
    CreateImportJobLogItemRequest
    """
    name: Optional[StrictStr] = None
    import_job_id: Optional[StrictStr] = Field(None, alias="importJobId")
    type: Optional[StrictStr] = None
    entity_id: Optional[StrictStr] = Field(None, alias="entityId")
    message: Optional[StrictStr] = None
    row_number: Optional[StrictInt] = Field(None, alias="rowNumber")
    modified_by_id: Optional[StrictStr] = Field(None, alias="modifiedById")
    __properties = ["name", "importJobId", "type", "entityId", "message", "rowNumber", "modifiedById"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreateImportJobLogItemRequest:
        """Create an instance of CreateImportJobLogItemRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreateImportJobLogItemRequest:
        """Create an instance of CreateImportJobLogItemRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CreateImportJobLogItemRequest.parse_obj(obj)

        _obj = CreateImportJobLogItemRequest.parse_obj({
            "name": obj.get("name"),
            "import_job_id": obj.get("importJobId"),
            "type": obj.get("type"),
            "entity_id": obj.get("entityId"),
            "message": obj.get("message"),
            "row_number": obj.get("rowNumber"),
            "modified_by_id": obj.get("modifiedById")
        })
        return _obj


