# coding: utf-8

"""
    AtroCore REST API documentation

    This is a REST API documentation for AtroCore data platform and its modules (AtroPIM, AtroDAM and others), which is based on [OpenAPI (Swagger) Specification](https://swagger.io/specification/). You can generate your client [here](https://openapi-generator.tech/docs/generators).<br><br><h3>Video tutorials:</h3><ul><li>[How to authorize?](https://youtu.be/GWfNRvCswXg)</li><li>[How to select specific fields?](https://youtu.be/i7o0aENuyuY)</li><li>[How to filter data records?](https://youtu.be/irgWkN4wlkM)</li></ul>

    The version of the OpenAPI document: 1.6.55
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr

class ImportJob(BaseModel):
    """
    ImportJob
    """
    id: Optional[StrictStr] = None
    deleted: Optional[StrictBool] = None
    name: StrictStr = Field(...)
    trial: Optional[StrictInt] = None
    import_feed_id: Optional[StrictStr] = Field(None, alias="importFeedId")
    import_feed_name: Optional[StrictStr] = Field(None, alias="importFeedName")
    sort_order: Optional[StrictStr] = Field(None, alias="sortOrder")
    entity_name: Optional[StrictStr] = Field(None, alias="entityName")
    state: StrictStr = Field(...)
    message: Optional[StrictStr] = None
    start: Optional[StrictStr] = None
    end: Optional[StrictStr] = None
    created_count: Optional[StrictInt] = Field(None, alias="createdCount")
    updated_count: Optional[StrictInt] = Field(None, alias="updatedCount")
    deleted_count: Optional[StrictInt] = Field(None, alias="deletedCount")
    errors_count: Optional[StrictInt] = Field(None, alias="errorsCount")
    attachment_id: Optional[StrictStr] = Field(None, alias="attachmentId")
    attachment_name: Optional[StrictStr] = Field(None, alias="attachmentName")
    uploaded_file_id: Optional[StrictStr] = Field(None, alias="uploadedFileId")
    uploaded_file_name: Optional[StrictStr] = Field(None, alias="uploadedFileName")
    converted_file_id: Optional[StrictStr] = Field(None, alias="convertedFileId")
    converted_file_name: Optional[StrictStr] = Field(None, alias="convertedFileName")
    errors_attachment_id: Optional[StrictStr] = Field(None, alias="errorsAttachmentId")
    errors_attachment_name: Optional[StrictStr] = Field(None, alias="errorsAttachmentName")
    created_at: Optional[StrictStr] = Field(None, alias="createdAt")
    modified_at: Optional[StrictStr] = Field(None, alias="modifiedAt")
    created_by_id: Optional[StrictStr] = Field(None, alias="createdById")
    created_by_name: Optional[StrictStr] = Field(None, alias="createdByName")
    modified_by_id: Optional[StrictStr] = Field(None, alias="modifiedById")
    modified_by_name: Optional[StrictStr] = Field(None, alias="modifiedByName")
    __properties = ["id", "deleted", "name", "trial", "importFeedId", "importFeedName", "sortOrder", "entityName", "state", "message", "start", "end", "createdCount", "updatedCount", "deletedCount", "errorsCount", "attachmentId", "attachmentName", "uploadedFileId", "uploadedFileName", "convertedFileId", "convertedFileName", "errorsAttachmentId", "errorsAttachmentName", "createdAt", "modifiedAt", "createdById", "createdByName", "modifiedById", "modifiedByName"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ImportJob:
        """Create an instance of ImportJob from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ImportJob:
        """Create an instance of ImportJob from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ImportJob.parse_obj(obj)

        _obj = ImportJob.parse_obj({
            "id": obj.get("id"),
            "deleted": obj.get("deleted"),
            "name": obj.get("name"),
            "trial": obj.get("trial"),
            "import_feed_id": obj.get("importFeedId"),
            "import_feed_name": obj.get("importFeedName"),
            "sort_order": obj.get("sortOrder"),
            "entity_name": obj.get("entityName"),
            "state": obj.get("state"),
            "message": obj.get("message"),
            "start": obj.get("start"),
            "end": obj.get("end"),
            "created_count": obj.get("createdCount"),
            "updated_count": obj.get("updatedCount"),
            "deleted_count": obj.get("deletedCount"),
            "errors_count": obj.get("errorsCount"),
            "attachment_id": obj.get("attachmentId"),
            "attachment_name": obj.get("attachmentName"),
            "uploaded_file_id": obj.get("uploadedFileId"),
            "uploaded_file_name": obj.get("uploadedFileName"),
            "converted_file_id": obj.get("convertedFileId"),
            "converted_file_name": obj.get("convertedFileName"),
            "errors_attachment_id": obj.get("errorsAttachmentId"),
            "errors_attachment_name": obj.get("errorsAttachmentName"),
            "created_at": obj.get("createdAt"),
            "modified_at": obj.get("modifiedAt"),
            "created_by_id": obj.get("createdById"),
            "created_by_name": obj.get("createdByName"),
            "modified_by_id": obj.get("modifiedById"),
            "modified_by_name": obj.get("modifiedByName")
        })
        return _obj


