# coding: utf-8

"""
    AtroCore REST API documentation

    This is a REST API documentation for AtroCore data platform and its modules (AtroPIM, AtroDAM and others), which is based on [OpenAPI (Swagger) Specification](https://swagger.io/specification/). You can generate your client [here](https://openapi-generator.tech/docs/generators).<br><br><h3>Video tutorials:</h3><ul><li>[How to authorize?](https://youtu.be/GWfNRvCswXg)</li><li>[How to select specific fields?](https://youtu.be/i7o0aENuyuY)</li><li>[How to filter data records?](https://youtu.be/irgWkN4wlkM)</li></ul>

    The version of the OpenAPI document: 1.6.55
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr

class PseudoTransactionJob(BaseModel):
    """
    PseudoTransactionJob
    """
    id: Optional[StrictStr] = None
    deleted: Optional[StrictBool] = None
    sort_order: Optional[StrictInt] = Field(None, alias="sortOrder")
    entity_type: Optional[StrictStr] = Field(None, alias="entityType")
    entity_id: Optional[StrictStr] = Field(None, alias="entityId")
    action: Optional[StrictStr] = None
    input_data: Optional[Dict[str, Any]] = Field(None, alias="inputData")
    created_by_id: Optional[StrictStr] = Field(None, alias="createdById")
    created_by_name: Optional[StrictStr] = Field(None, alias="createdByName")
    parent_id: Optional[StrictStr] = Field(None, alias="parentId")
    parent_name: Optional[StrictStr] = Field(None, alias="parentName")
    md5: Optional[StrictStr] = None
    __properties = ["id", "deleted", "sortOrder", "entityType", "entityId", "action", "inputData", "createdById", "createdByName", "parentId", "parentName", "md5"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PseudoTransactionJob:
        """Create an instance of PseudoTransactionJob from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PseudoTransactionJob:
        """Create an instance of PseudoTransactionJob from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PseudoTransactionJob.parse_obj(obj)

        _obj = PseudoTransactionJob.parse_obj({
            "id": obj.get("id"),
            "deleted": obj.get("deleted"),
            "sort_order": obj.get("sortOrder"),
            "entity_type": obj.get("entityType"),
            "entity_id": obj.get("entityId"),
            "action": obj.get("action"),
            "input_data": obj.get("inputData"),
            "created_by_id": obj.get("createdById"),
            "created_by_name": obj.get("createdByName"),
            "parent_id": obj.get("parentId"),
            "parent_name": obj.get("parentName"),
            "md5": obj.get("md5")
        })
        return _obj


