# coding: utf-8

"""
    AtroCore REST API documentation

    This is a REST API documentation for AtroCore data platform and its modules (AtroPIM, AtroDAM and others), which is based on [OpenAPI (Swagger) Specification](https://swagger.io/specification/). You can generate your client [here](https://openapi-generator.tech/docs/generators).<br><br><h3>Video tutorials:</h3><ul><li>[How to authorize?](https://youtu.be/GWfNRvCswXg)</li><li>[How to select specific fields?](https://youtu.be/i7o0aENuyuY)</li><li>[How to filter data records?](https://youtu.be/irgWkN4wlkM)</li></ul>

    The version of the OpenAPI document: 1.6.55
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr

class Sharing(BaseModel):
    """
    Sharing
    """
    id: Optional[StrictStr] = None
    deleted: Optional[StrictBool] = None
    name: Optional[StrictStr] = None
    description: Optional[StrictStr] = None
    active: Optional[StrictBool] = None
    available: Optional[StrictBool] = None
    entity_type: StrictStr = Field(..., alias="entityType")
    entity_id: StrictStr = Field(..., alias="entityId")
    type: StrictStr = Field(...)
    valid_till: Optional[StrictStr] = Field(None, alias="validTill")
    allowed_usage: Optional[StrictInt] = Field(None, alias="allowedUsage")
    used: Optional[StrictInt] = None
    link: Optional[StrictStr] = None
    created_at: Optional[StrictStr] = Field(None, alias="createdAt")
    modified_at: Optional[StrictStr] = Field(None, alias="modifiedAt")
    created_by_id: Optional[StrictStr] = Field(None, alias="createdById")
    created_by_name: Optional[StrictStr] = Field(None, alias="createdByName")
    modified_by_id: Optional[StrictStr] = Field(None, alias="modifiedById")
    modified_by_name: Optional[StrictStr] = Field(None, alias="modifiedByName")
    __properties = ["id", "deleted", "name", "description", "active", "available", "entityType", "entityId", "type", "validTill", "allowedUsage", "used", "link", "createdAt", "modifiedAt", "createdById", "createdByName", "modifiedById", "modifiedByName"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Sharing:
        """Create an instance of Sharing from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Sharing:
        """Create an instance of Sharing from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Sharing.parse_obj(obj)

        _obj = Sharing.parse_obj({
            "id": obj.get("id"),
            "deleted": obj.get("deleted"),
            "name": obj.get("name"),
            "description": obj.get("description"),
            "active": obj.get("active"),
            "available": obj.get("available"),
            "entity_type": obj.get("entityType"),
            "entity_id": obj.get("entityId"),
            "type": obj.get("type"),
            "valid_till": obj.get("validTill"),
            "allowed_usage": obj.get("allowedUsage"),
            "used": obj.get("used"),
            "link": obj.get("link"),
            "created_at": obj.get("createdAt"),
            "modified_at": obj.get("modifiedAt"),
            "created_by_id": obj.get("createdById"),
            "created_by_name": obj.get("createdByName"),
            "modified_by_id": obj.get("modifiedById"),
            "modified_by_name": obj.get("modifiedByName")
        })
        return _obj


